

#include "stdafx.h"
#include "Art.h"
#include "ArtDlg.h"
#include "Globals.h"
#include "hyperlink.h"
#include "InputErrorUv.h"
#include "DialogFindAndReplace.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

extern int g_separatorComma;

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);

protected:
public:
	CHyperLink m_hyperlink;
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_HYPERLINK, m_hyperlink);
}




CArtDlg::CArtDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CArtDlg::IDD, pParent)
	, m_width( 0 )
	, m_height( 0 )
	, m_dpiX( 0 )
	, m_dpiY( 0 )
	, m_numberOfConditions(1)
	, m_numberOfUvs(1)
	, m_actualConditionNumber(0)
	, m_outfile("")
	, m_artFilePath(_T(""))
	, m_somethingToSave(false)
	, m_tabs(true)
	, m_blanks(false)
	, m_crs(true)
	, m_newLines(false)
	, m_vertTabs(false)
	, m_newPages(false)
	, actProtocolFilenumber( -1 )
{
	/*m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);*/
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_condset = new ExpConditionSet( 1 );
	m_copyCondset = new ExpConditionSet( 1 );
	m_uvSet = new UvSet;
	m_condset->addCondition("");
}

CArtDlg::~CArtDlg(void)
{
	delete m_condset;
	delete m_copyCondset;

	delete m_uvSet;

	for( int i = 0; i < protocolFileChanges.GetSize( ); i++ )
		delete protocolFileChanges.GetAt( i );
}


//LRESULT CArtDlg::WindowProc(UINT message,WPARAM wParam,LPARAM lParam)
//{
//	if (message == WM_DPICHANGED)
//	{
//		int newDpi = HIWORD(wParam);
//		double scaFa = (double)newDpi / (double)m_dpiX;
//
//		UINT newWidth = m_width * scaFa;
//		UINT newHeight = m_height * scaFa;
//
//		m_dpiX = newDpi;
//		m_dpiY = newDpi;
//
//		LPRECT newRect = (LPRECT)lParam;
//		SetWindowPos(NULL, newRect->left, newRect->top, newRect->right - newRect->left, newRect->bottom - newRect->top, SWP_NOMOVE | SWP_NOZORDER);
//			
//		this->SetWindowPos(NULL, 0, 0, newWidth, newHeight, SWP_NOMOVE | SWP_NOZORDER);
//		this->positionDialogControls();
//		Invalidate();
//	}
//	else
//		return CDialog::WindowProc(message, wParam, lParam);
//}


void CArtDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_GridControl (pDX, IDC_GRID, m_gridAv);
	DDX_GridControl (pDX, IDC_GRID2, m_gridUv);
	DDX_GridControl (pDX, IDC_GRID_PREVIEW, m_gridPreview);
	DDX_GridControl (pDX, IDC_GRID_CONDS, m_gridConds);
	DDX_Control(pDX, IDC_SPIN_COND_NUMBER, m_spinConditionNumber);
	DDX_Control(pDX, IDC_EDIT_COND_NUMBER, m_editConditionNumber);
	DDX_Control(pDX, IDC_EDIT_COND_NAME, m_editCondName);
	DDX_Control(pDX, IDC_CHECK_TABS, m_checkTabs);
	DDX_Control(pDX, IDC_CHECK_BLANKS, m_checkBlanks);
	DDX_Control(pDX, IDC_EDIT_COLUMN_AV, m_editColumnAv);
	DDX_Control(pDX, IDC_EDIT_LINE_FROM, m_editLineFrom);
	DDX_Control(pDX, IDC_EDIT_LINE_TO, m_editLineTo);

	DDX_Control(pDX, IDC_RADIO_RAW_VALUES, m_radioRawValues);
	DDX_Control(pDX, IDC_RADIO_MEAN, m_radioMean);
	DDX_Control(pDX, IDC_RADIO_MEDIAN, m_radioMedian);
	DDX_Control(pDX, IDC_RADIO_INCIDENCES, m_radioIncidences);
	DDX_Control(pDX, IDC_RADIO_SUMME, m_radioSumme);
	DDX_Control(pDX, IDC_RADIO_VARIANCE, m_radioVariance);
	DDX_Control(pDX, IDC_RADIO_STANDARD_DEVIATION, m_radioStandardDeviation);
	DDX_Control(pDX, IDC_CHECK_POPULATION_ESTIMATION, m_checkPopEst);

	DDX_Control(pDX, IDC_BUTTON_UV_FROM_PREVIEW, m_buttonFromPreview);
	DDX_Control(pDX, IDC_STATIC_BETWEEN_SUBJECTS, m_staticBetweenSubjects);
	DDX_Control(pDX, IDC_BUTTON_START, m_buttonStart);
	DDX_Control(pDX, IDC_BUTTON_OPTIONS, m_buttonOptions);
	DDX_Control(pDX, IDC_CHECK_SPECIAL_AV, m_checkSpecialAv);
	DDX_Control(pDX, IDC_STATIC_WITHIN_SUBJECTS, m_staticWithinSubjects);
	DDX_Control(pDX, IDC_BUTTON_AV_FROM_PREVIEW, m_buttonWithinFromPreview);
	DDX_Control(pDX, IDC_STATIC_LINE_FROM, m_staticLineFrom);
	DDX_Control(pDX, IDC_STATIC_LINE_TO, m_staticLineTo);
	DDX_Control(pDX, IDC_STATIC_COLUMN_AV, m_staticColumnAv);
	DDX_Control(pDX, IDC_STATIC_NAME, m_staticName);
	DDX_Control(pDX, IDC_STATIC_CONDITION_NUMBER, m_staticConditionNumber);
	DDX_Control(pDX, IDC_STATIC_DELIMITERS, m_staticDelimiters);
	DDX_Control(pDX, IDC_CHECK_CR, m_checkCR);
	DDX_Control(pDX, IDC_CHECK_NEW_LINE, m_checkNewLine);
	DDX_Control(pDX, IDC_CHECK_VERT_TAB, m_checkVertTab);
	DDX_Control(pDX, IDC_CHECK_NEW_PAGE, m_checkNewPage);
	DDX_Control(pDX, IDC_STATIC_VERTICAL, m_staticVertical);
	DDX_Control(pDX, IDC_STATIC_HORIZONTAL, m_staticHorizontal);
	DDX_Control(pDX, IDC_STATIC_PROTOCOLS_SELECTED, m_staticProtocolsSelected);
	DDX_Control(pDX, IDC_CHECK_FILE_END, m_checkFileEnd);
	DDX_Control(pDX, IDC_EDIT_FILE_IN_PREVIEW, m_editFileInPreview);
	DDX_Control(pDX, IDC_SPIN_FILE_IN_PREVIEW, m_spinFileInPreview);
	DDX_Control(pDX, IDC_STATIC_FILE, m_staticFile);
}

BEGIN_MESSAGE_MAP(CArtDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_START, OnBnClickedButtonStart)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_COND_NUMBER, OnDeltaposSpinCondNumber)
	
	//Grid-Messages
	ON_NOTIFY(GVN_SELCHANGED, IDC_GRID, OnGridEndSelChange)
	ON_NOTIFY(NM_CLICK, IDC_GRID_CONDS, OnCondsGridClick)

	ON_BN_CLICKED(IDC_CHECK_TABS, OnBnClickedCheckTabs)
	ON_BN_CLICKED(IDC_CHECK_BLANKS, OnBnClickedCheckBlanks)
	ON_BN_CLICKED(IDC_BUTTON_AV_FROM_PREVIEW, OnBnClickedButtonAvFromPreview)
	ON_BN_CLICKED(IDC_BUTTON_UV_FROM_PREVIEW, OnBnClickedButtonUvFromPreview)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_EDIT_COPY_SELECTION, OnEditCopySelection)
	ON_COMMAND(ID_EDIT_CUT_SELECTION, OnEditCutSelection)
	ON_COMMAND(ID_EDIT_PASTE_SELECTION, OnEditPasteSelection)
	ON_COMMAND(ID_EDIT_APPEND_SELECTION, OnEditAppendSelection)
	ON_COMMAND(ID_WITHIN_SUBJECTS_INSERT_RULE, OnWithinSubjectsInsertRule)
	ON_COMMAND(ID_WITHIN_SUBJECTS_INSERT_OR_BLOCK, OnWithinSubjectsInsertOrBlock)
	ON_COMMAND(ID_WITHIN_SUBJECTS_DELETE_RULE, OnWithinSubjectsDeleteRule)
	ON_COMMAND(ID_WITHIN_SUBJECTS_ADD_CONDITION, OnWithinSubjectsAddCondition)
	ON_COMMAND(ID_WITHIN_SUBJECTS_COPY_CONDITION, OnWithinSubjectsCopyCondition)
	ON_COMMAND(ID_WITHIN_SUBJECTS_DELETE_CONDITION, OnWithinSubjectsDeleteCondition)
	ON_COMMAND(ID_WITHIN_SUBJECTS_INSERT_LINE, OnWithinSubjectsInsertLine)
	ON_COMMAND(ID_WITHIN_SUBJECTS_DELETE_LINES, OnWithinSubjectsDeleteLines)
	ON_COMMAND(ID_FILE_SELECT_INPUT_FILES, OnFileSelectInputFiles)
	ON_COMMAND(ID_FILE_SELECT_OUTPUT_FILE, OnFileSelectOutputFile)
	ON_COMMAND(ID_FILE_QUIT, OnFileQuit)
	ON_COMMAND(ID_BETWEEN_SUBJECTS_ADD_LINE, OnBetweenSubjectsAddLine)
	ON_COMMAND(ID_BETWEEN_SUBJECTS_DELETE_LINE, OnBetweenSubjectsDeleteLines)
	ON_BN_CLICKED(IDC_RADIO_MEAN, OnBnClickedRadioMean)
	ON_BN_CLICKED(IDC_RADIO_MEDIAN, OnBnClickedRadioMedian)
	ON_WM_SIZE()
	ON_WM_GETMINMAXINFO()
	ON_BN_CLICKED(IDC_RADIO_INCIDENCES, &CArtDlg::OnBnClickedRadioIncidences)
	ON_BN_CLICKED(IDC_BUTTON_OPTIONS, OnBnClickedOptions)
	ON_BN_CLICKED(IDC_CHECK_SPECIAL_AV, &CArtDlg::OnBnClickedCheckSpecialAv)
	ON_STN_CLICKED(IDC_STATIC_NAME, &CArtDlg::OnStnClickedStaticName)
	ON_WM_ERASEBKGND()
	ON_COMMAND(ID_FILE_SAVEAS, &CArtDlg::OnFileSaveas)
	ON_BN_CLICKED(IDC_CHECK_CR, &CArtDlg::OnBnClickedCheckCr)
	ON_BN_CLICKED(IDC_CHECK_NEW_LINE, &CArtDlg::OnBnClickedCheckNewLine)
	ON_BN_CLICKED(IDC_CHECK_VERT_TAB, &CArtDlg::OnBnClickedCheckVertTab)
	ON_BN_CLICKED(IDC_CHECK_NEW_PAGE, &CArtDlg::OnBnClickedCheckNewPage)
	ON_COMMAND(ID_EDIT_COPY, &CArtDlg::OnEditCopy)
	ON_COMMAND(ID_EDIT_CUT, &CArtDlg::OnEditCut)
	ON_COMMAND(ID_EDIT_PASTE, &CArtDlg::OnEditPaste)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, &CArtDlg::OnUpdateEditPaste)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE32839, &CArtDlg::OnUpdateEditPaste)
	ON_WM_MENUSELECT()
	ON_WM_INITMENUPOPUP()
	ON_COMMAND(ID_EDIT_CLEAR, &CArtDlg::OnEditClear)
	ON_COMMAND(ID_EDIT_CLEARALL, &CArtDlg::OnEditClearall)
	ON_COMMAND(ID_EDIT_SELECTALL, &CArtDlg::OnEditSelectall)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CLEARALL, &CArtDlg::OnUpdateEditClearall)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CLEAR, &CArtDlg::OnUpdateEditIsSel)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, &CArtDlg::OnUpdateEditIsSel)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CUT, &CArtDlg::OnUpdateEditIsSel)
	ON_UPDATE_COMMAND_UI(ID_EDIT_SELECTALL, &CArtDlg::OnUpdateEditSelectall)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE_SELECTION, &CArtDlg::OnUpdateCondsToPaste)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CUT_SELECTION, &CArtDlg::OnUpdateCondsSelected)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY_SELECTION, &CArtDlg::OnUpdateCondsSelected)
	ON_UPDATE_COMMAND_UI(ID_EDIT_APPEND_SELECTION, &CArtDlg::OnUpdateCondsSelected)
	ON_UPDATE_COMMAND_UI(ID_WITHIN_SUBJECTS_DELETE_CONDITION, &CArtDlg::OnUpdateCondsSelected)
	ON_UPDATE_COMMAND_UI(ID_WITHIN_SUBJECTS_COPY_CONDITION, &CArtDlg::OnUpdateCondsSelected)
	ON_UPDATE_COMMAND_UI(ID_WITHIN_SUBJECTS_DELETE_LINES, &CArtDlg::OnUpdateAvLinesSelected)
	ON_UPDATE_COMMAND_UI(ID_WITHIN_SUBJECTS_INSERT_LINE, &CArtDlg::OnUpdateAvLinesSelected)
	ON_UPDATE_COMMAND_UI(ID_WITHIN_SUBJECTS_INSERT_RULE, &CArtDlg::OnUpdateCondsAvailable)
	ON_UPDATE_COMMAND_UI(ID_WITHIN_SUBJECTS_INSERT_OR_BLOCK, &CArtDlg::OnUpdateCondsAvailable)
	ON_UPDATE_COMMAND_UI(ID_BETWEEN_SUBJECTS_DELETE_LINE, &CArtDlg::OnUpdateUvLinesSelected)
	ON_WM_SIZING()
	ON_COMMAND(ID_HELP_ABOUTART, &CArtDlg::OnHelpAboutArt)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE, &CArtDlg::OnUpdateSomethingToSave)
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_RADIO_VARIANCE, &CArtDlg::OnBnClickedRadioVariance)
	ON_BN_CLICKED(IDC_RADIO_STANDARD_DEVIATION, &CArtDlg::OnBnClickedRadioStandardDeviation)
	ON_BN_CLICKED(IDC_CHECK_POPULATION_ESTIMATION, &CArtDlg::OnBnClickedCheckPopulationEstimation)
	ON_BN_CLICKED(IDC_RADIO_SUMME, &CArtDlg::OnBnClickedRadioSumme)
	ON_BN_CLICKED(IDC_CHECK_FILE_END, &CArtDlg::OnBnClickedCheckFileEnd)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_FILE_IN_PREVIEW, &CArtDlg::OnDeltaposSpinFileInPreview)
	ON_EN_CHANGE(IDC_EDIT_FILE_IN_PREVIEW, &CArtDlg::OnEnChangeEditFileInPreview)
	ON_EN_CHANGE(IDC_EDIT_COND_NUMBER, &CArtDlg::OnEnChangeEditCondNumber)
	ON_COMMAND(ID_PROTOCOLFILES_DELETESELECTEDROW, &CArtDlg::OnProtocolfilesDeleteselectedrows)
	ON_COMMAND(ID_PROTOCOLFILES_DELETESELECTEDCOLUMN, &CArtDlg::OnProtocolfilesDeleteselectedcolumns)
	ON_COMMAND(ID_PROTOCOLFILES_UNDOLASTCHANGE, &CArtDlg::OnProtocolfilesUndolastchange)
	ON_UPDATE_COMMAND_UI(ID_PROTOCOLFILES_UNDOLASTCHANGE, &CArtDlg::OnUpdateProtocolfilesUndolastchange)
	ON_UPDATE_COMMAND_UI(ID_PROTOCOLFILES_DELETESELECTEDROW, &CArtDlg::OnUpdateProtocolfilesDeleteselectedrows)
	ON_UPDATE_COMMAND_UI(ID_PROTOCOLFILES_DELETESELECTEDCOLUMN, &CArtDlg::OnUpdateProtocolfilesDeleteselectedcolumns)
	ON_COMMAND(ID_PROTOCOLFILES_FINDANDREPLACE, &CArtDlg::OnProtocolfilesFindandreplace)
	ON_BN_CLICKED(IDC_RADIO_RAW_VALUES, &CArtDlg::OnBnClickedRadioRawValues)
END_MESSAGE_MAP()



BOOL CArtDlg::getdpi()
{
	//// Windows 8.1-version
	//POINT    point;
	//point.x = 1;
	//point.y = 1;

	//auto hMonitor = MonitorFromPoint(point, MONITOR_DEFAULTTONEAREST);
	//auto hr = GetDpiForMonitor(hMonitor, MDT_EFFECTIVE_DPI, &m_dpiX, &m_dpiY);

	//if (hr != S_OK)
	//{
	//	MessageBoxW(NULL, (LPCWSTR)L"GetDpiForMonitor failed", (LPCWSTR)L"Notification", MB_OK);
	//	return FALSE;
	//}

	// General version
	FLOAT dpiX, dpiY;

	CDC *screen = GetDC();
	dpiX = static_cast<FLOAT>(GetDeviceCaps(*screen, LOGPIXELSX));
	dpiY = static_cast<FLOAT>(GetDeviceCaps(*screen, LOGPIXELSY));
	ReleaseDC(screen);

	m_dpiX = dpiX;
	m_dpiY = dpiY;

	return TRUE;
}




BOOL CArtDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	
	SetIcon(m_hIcon, TRUE);			
	SetIcon(m_hIcon, FALSE);	

	getdpi();
	
	
	initGridAv();
	initGridUv();
	initGridConds();
	initControls();
	
	returnExpCondition( m_actualConditionNumber );

	// Accelerators
	m_hAccel = ::LoadAccelerators(AfxGetInstanceHandle(),
                              MAKEINTRESOURCE(IDR_ACCELERATOR1));

	m_gridAv.SetDoubleBuffering( TRUE );
	m_gridUv.SetDoubleBuffering( TRUE );
	m_gridConds.SetDoubleBuffering( TRUE );

	// When resizing the children's grey background will not be redrawn.
	// This prevents flickering.
	ModifyStyle(0, WS_CLIPCHILDREN | WS_CLIPSIBLINGS ); 

	
	m_specialAvDlg = new SpecialAvDlg( );
	m_specialAvDlg->getComputedAv( m_condset->at( m_actualConditionNumber )->retComputedAv() );

	//m_buttonOptions.EnableWindow( FALSE );

	// head line of main window
	this->SetWindowText( _T("ART") );

	//SetCapture( );

	// find regional decimal separator.
	findDecimalSeparator();

	/*CString *filePath = new CString( __argv[1] );*/

	CString filePath( __argv[1] );
	ShowWindow( SW_SHOW );

	if( filePath != _T( "" ) )
	{
		if( filePath.Right( 4 ) == _T( ".art" ) )
		{
			openArtFile( filePath );

			/*CString windowTitle( filePath );
			windowTitle.Append( _T( " - ART" ) );
			this->SetWindowTextA( windowTitle );*/
		}
		else
		{
			m_filenames.RemoveAll();

			int fileNumber = 1;

			while( filePath != _T( "" ) )
			{
				if (filePath.Find(":\\\\") == 1 && filePath.GetLength() > 4)
				{
					// this means we have an invalid path that looks like this:
					// C:\\cda.dgl
					// get rid of extra slash
					CString temp;
					temp = filePath.Left(3);
					temp += filePath.Mid(4);
					filePath = temp;
				}
				
				m_filenames.Add( filePath );

				fileNumber++;
				filePath = __argv[fileNumber];
			}

			if( m_filenames.GetSize() > 0 )
			{
				m_editFileInPreview.EnableWindow( TRUE );
				m_spinFileInPreview.EnableWindow( TRUE );
				m_spinFileInPreview.SetRange32( 1, m_filenames.GetSize() );
				m_spinFileInPreview.SetPos32( 1 );
				previewFile();
			}
			else
			{
				m_editFileInPreview.EnableWindow( FALSE );
				m_spinFileInPreview.EnableWindow( FALSE );
			}

			CString textSelected;
			textSelected.Format( _T( "of %d protocol file" ), m_filenames.GetSize() );

			if( m_filenames.GetSize() != 1 )
				textSelected.Append( "s" );

			m_staticProtocolsSelected.SetWindowTextA( textSelected );
		}

	}


	positionDialogControls();

	return TRUE; 
}

void CArtDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CArtDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for drawing

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// center symbol in client rect
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// draw symbol
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CArtDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

BOOL CArtDlg::findDecimalSeparator()
{
	TCHAR pszBuf[4];
	if ( GetLocaleInfo( LOCALE_USER_DEFAULT, LOCALE_SDECIMAL, pszBuf, 4 ) < 1 )
	{
	 // error ...
	}

	if( strcmp( pszBuf, "," ) == 0 ) // regional setting comma as decimal-separator
		g_separatorComma = TRUE;
	else
		g_separatorComma = FALSE;

	return g_separatorComma;
}


void CArtDlg::OnBnClickedButtonStart()
{
	// Capture actual condition
	m_editConditionNumber.SetFocus();
	setExpCondition( m_actualConditionNumber );

	CString errorString;
	InputError inputError;
	InputErrorUv inputErrorUv;
	BOOL inputErrorOccured;


	if ( checkInputFiles() && checkOutputFiles() )
	{
		CString oldWindowText;
		this->GetWindowTextA( oldWindowText );

		this->SetWindowText( _T("ART - Computing ...") );

		WTextFile *theTextFile;
		
		// Find out how many lines are needed for output file
		int totalNumberOfNeededLines = 0;

		for (int i=0; i < m_filenames.GetSize(); i++)
		{
			CString cFilename( m_filenames.GetAt( i ) );
		
			theTextFile = new WTextFile( cFilename.AllocSysString( ), m_crs, m_newLines, m_vertTabs, m_newPages, m_tabs, m_blanks );
			theTextFile->readFile( );

			applyProtocolFileChanges( theTextFile );

			if( m_condset->returnSize( ) > 0 )
			{
				totalNumberOfNeededLines += m_condset->checkAllConditions( theTextFile );
			}


			delete theTextFile;
		}

		int totalNumberOfNeededColumns = m_numberOfConditions + m_numberOfUvs;

		




		OutFile *outFile = new OutFile( m_outfile.GetBuffer( ), totalNumberOfNeededLines, totalNumberOfNeededColumns );

		// Init out file by emptiing any 'cell'
		for( int line = 0; line < (totalNumberOfNeededLines + 1); line++ ) // output file contains one more line for the headline
		{
			for( int column = 0; column < totalNumberOfNeededColumns; column++ )
			{
				outFile->getWord("", line, column );
			}
		}
	

		setUvs();

		int actOutFileLine = 1;
		
		for (int i=0; i < m_filenames.GetSize(); i++)
		{
			CString cFilename( m_filenames.GetAt( i ) );
		
			theTextFile = new WTextFile( cFilename.AllocSysString( ), m_crs, m_newLines, m_vertTabs, m_newPages, m_tabs, m_blanks );
			theTextFile->readFile( );

			applyProtocolFileChanges( theTextFile );

			//////////////////////////////////////////////////////////////////////////////////////////////////////////////
			///////////////////////////////////////// Check for input errors /////////////////////////////////////////////
			//////////////////////////////////////////////////////////////////////////////////////////////////////////////

			inputError = m_condset->checkValidInputs( theTextFile );
			inputErrorUv = m_uvSet->checkValidInputs( theTextFile );

			inputErrorOccured = inputError.errorCode || inputErrorUv.errorCode;

			if( inputError.errorCode )
			{
				errorString = inputError.errorString;
				errorString.Append( _T( " in within-subjects variable '" ) );
				errorString.Append( m_condset->at( inputError.expCondition )->returnName() );
				errorString.Append( _T( "'.\n\nError occured while processing file " ) );
			}

			if( inputErrorUv.errorCode )
			{
				errorString = inputErrorUv.errorString;
				errorString.Append( _T( " in between-subjects variable '" ) );
				errorString.Append( m_uvSet->at( inputErrorUv.uvWithError )->returnName() );
				errorString.Append( _T( "'.\nError occured while processing file " ) );
			}

			if( inputErrorOccured )
			{
				CString stringFileNumber;
				stringFileNumber.Format( _T( "%d" ), i+1 );

				errorString.Append( stringFileNumber );
				errorString.Append( _T( ".\n\n(") );
				errorString.Append( cFilename );
				errorString.Append( _T( ")" ) );

				MessageBox( errorString, _T("Error"), MB_ICONSTOP );

				// show protocol-file, in which the error occurred
				m_spinFileInPreview.SetPos32( i+1 );
				previewFile( i );
			}
				
			
			if( inputError.errorCode )
				showCondition( inputError.expCondition );

			// Do not continue in case of error
			if( inputErrorOccured )	
				return;

			//////////////////////////////////////////////////////////////////////////////////////////////////////////////
			///////////////////////////////////////// End of input error check ///////////////////////////////////////////
			//////////////////////////////////////////////////////////////////////////////////////////////////////////////
			

			m_uvSet->SetAllValues( theTextFile );
			m_uvSet->WriteAllConditionsToOutFile( outFile, actOutFileLine );

			
			if( m_condset->returnSize( ) > 0 )
			{
				m_condset->checkAllConditions( theTextFile );
			}

			int maxNumberOfNeededLines = m_condset->WriteAllConditionsToOutFile( outFile, actOutFileLine, m_gridUv.GetRowCount() - 1 );
			actOutFileLine += maxNumberOfNeededLines;
			
			
			delete theTextFile;

			if( i % 100 == 0 )
				pumpMessages();
		} // for (int i=0; i < m_filenames.size(); i++)

		//outFile->showWordArray();
		outFile->SaveToFile();
		
		delete outFile;

		
		this->SetWindowText( oldWindowText );

		CString outText = _T( "Your data were processed and have been saved to\n" );
		outText.Append(	m_outfile.GetBuffer( ) );
		
		
		MSGBOXPARAMS params = {0};
		params.cbSize = sizeof MSGBOXPARAMS;
		params.hInstance = GetModuleHandle( NULL );
		params.lpszText = outText;
		params.lpszCaption = "Done";
		params.dwStyle = MB_OK | MB_USERICON;
		params.dwLanguageId = MAKELANGID(LANG_NEUTRAL,SUBLANG_NEUTRAL);
		params.lpszIcon = MAKEINTRESOURCE(IDR_MAINFRAME);
		MessageBoxIndirect (&params);
	} // if ( checkInputFiles() && checkOutputFiles() )
}

void CArtDlg::pumpMessages()
{
	MSG msg;

	PeekMessage(&msg,0,0,0,PM_NOREMOVE);
	AfxGetThread()->PumpMessage();
}

void CArtDlg::setExpCondition(int conditionNumber)
{
	if( (conditionNumber < 0) || (conditionNumber > (m_condset->returnSize() - 1)) )
		return;

	m_somethingToSave = true;

	CString condName, columnAvStr, lineFromStr, lineToStr;

	m_editCondName.GetWindowText( condName );
	m_editColumnAv.GetWindowText( columnAvStr );
	m_editLineFrom.GetWindowText( lineFromStr );
	m_editLineTo.GetWindowText( lineToStr );

	int columnAv = _ttoi((LPCTSTR)columnAvStr)-1;
	int lineFrom  = _ttoi((LPCTSTR)lineFromStr)-1;
	int lineTo  = _ttoi((LPCTSTR)lineToStr)-1;
	
	m_condset->at( conditionNumber )->setLineToFileEnd( m_checkFileEnd.GetCheck() );

	m_condset->at( conditionNumber )->setName( condName );

	if( columnAv > -1 )
		m_condset->at( conditionNumber )->setColumnAv( columnAv );

	if( lineFrom > -1 )
		m_condset->at( conditionNumber )->setFirstLine( lineFrom );

	if( lineTo > -1 )
		m_condset->at( conditionNumber )->setLastLine( lineTo );

	int centTendency;

	if( m_radioRawValues.GetCheck( ) )
		centTendency = 6;
	else if( m_radioMean.GetCheck( ) )
		centTendency = 0;
	else if( m_radioMedian.GetCheck( ) )
		centTendency = 1;
	else if( m_radioIncidences.GetCheck( ) )
		centTendency = 2;
	else if( m_radioSumme.GetCheck( ) )
		centTendency = 3;
	else if( m_radioVariance.GetCheck( ) )
		centTendency = 4;
	else if( m_radioStandardDeviation.GetCheck( ) )
		centTendency = 5;
		
	m_condset->at( conditionNumber )->setPopEst( m_checkPopEst.GetCheck() );

	m_condset->at( conditionNumber )->setCentTendency( centTendency );
	m_condset->at( conditionNumber )->setSpecialAv( m_checkSpecialAv.GetCheck() );

	for (int i=0; i < m_condset->at( conditionNumber )->returnNumberOfSubConds(); i++)
	{
		setSubCondition( conditionNumber, i );
	}
}


void CArtDlg::setSubCondition(int conditionNumber, int subCondNumber)
{
	BOOL orType = m_condset->at(conditionNumber)->at( subCondNumber )->orType;
	int line = m_condset->at(conditionNumber)->returnSubCondStartPos( subCondNumber ) + 1;
	
	if (! orType)
	{
		// column-string
		CString columnString = m_gridAv.GetItemText( line, 0 );
		int column = ( _ttoi((LPCTSTR)columnString) ) - 1;

		// comparator string
		CString comparatorString = m_gridAv.GetItemText( line, 1 );
		int comparator = convertComparator( comparatorString );

		// referenceType
		CString referenceTypeString = m_gridAv.GetItemText( line, 3 );
		int referenceType = convertReferenceType( referenceTypeString );

		// reference string
		CString referenceString = m_gridAv.GetItemText( line, 2 );
		referenceString.Replace( _T( "," ), _T( "." ) );

		if ( ! m_gridAv.returnGridCheck( line, 4 ) ) // not as text
		{
			double reference = _tstof((LPCTSTR)referenceString);

			if( (column > -1) && (referenceType > -1) )
				m_condset->at(conditionNumber)->replaceSubCondition( subCondNumber, column, comparator, reference, referenceType );
		}
		else // as text
		{
			m_condset->at(conditionNumber)->replaceSubCondition( subCondNumber,
			column, comparator, referenceString, referenceType );
		}
	}
	else
	{
		OrSubCondition *theOrCond = ((OrSubCondition*) (m_condset->at(conditionNumber)->at(subCondNumber)));
		int numberOfSubSubConds = theOrCond->size;

		for (int i=0; i < numberOfSubSubConds; i++)
		{
			CString columnString = m_gridAv.GetItemText( line, 0 );
			int column = ( _ttoi((LPCTSTR)columnString) ) - 1;

			// comparator string
			CString comparatorString = m_gridAv.GetItemText( line, 1 );
			int comparator = convertComparator( comparatorString );

			// reference type
			CString referenceTypeString = m_gridAv.GetItemText( line, 3 );
			int referenceType = convertReferenceType( referenceTypeString );

			// reference string
			CString referenceString = m_gridAv.GetItemText( line, 2 );
			referenceString.Replace( _T( "," ), _T( "." ) );

			if ( ! m_gridAv.returnGridCheck( line, 4 ) ) // not as text
			{
				double reference = _tstof((LPCTSTR)referenceString);

				if( (column > -1) && (referenceType > -1) )
					theOrCond->replaceSubCondition( i, column, comparator, reference, referenceType );
			}
			else // as text
			{
				theOrCond->replaceSubCondition( i, column, comparator, referenceString, referenceType );
			}

			line++;
		}
	}
}

void CArtDlg::returnSubCondition( int conditionNumber, int subCondNumber,
										int startLine)
{
	int column, comparator;
	double referenceValue;
	int referenceType;

	CString columnStr, comparatorStr, referenceValueStr, referenceTypeStr;

	if (! m_condset->at(conditionNumber)->at(subCondNumber)->orType)
	{
		column = ( m_condset->at(conditionNumber)->returnColumn( subCondNumber ) ) + 1;
		columnStr.Format( _T("%d"), column );

		comparator = m_condset->at(conditionNumber)->returnComparator( subCondNumber );
		comparatorStr = convertComparator( comparator );

		referenceType = m_condset->at(conditionNumber)->returnReferenceType( subCondNumber );
		referenceTypeStr = convertReferenceType( referenceType );

		BOOL textRef = m_condset->at(conditionNumber)->at( subCondNumber )->textRef;
		if ( ! textRef )
		{
			referenceValue = m_condset->at(conditionNumber)->returnReferenceValue( subCondNumber );
			referenceValueStr.Format( _T("%.5g"), referenceValue );

			if( g_separatorComma )
				referenceValueStr.Replace( _T( "." ), _T( "," ) );
		}
		else
		{
			referenceValueStr = m_condset->at(conditionNumber)->returnReferenceValueText( subCondNumber );
		}
		

		m_gridAv.SetItemText( startLine, 0, columnStr );
		m_gridAv.SetItemText( startLine, 1, comparatorStr );
		m_gridAv.SetItemText( startLine, 3, referenceTypeStr );
		m_gridAv.SetItemText( startLine, 2, referenceValueStr );
		m_gridAv.setGridCheck( startLine, 4, textRef );
		m_gridAv.setGridRowWhite( startLine );
	}
	else
	{
		int subCondSize = m_condset->at(conditionNumber)->returnSubCondSize( subCondNumber );
		int pinkType = 1;

		if (m_gridAv.getGridRowColorType(startLine-1) == 1)
			pinkType = 2;
		
		for (int i=0; i < subCondSize; i++)
		{
			column = ( m_condset->at(conditionNumber)->returnColumn( subCondNumber, i ) ) + 1;
			columnStr.Format( _T("%d"), column );

			comparator = m_condset->at(conditionNumber)->returnComparator( subCondNumber, i );
			comparatorStr = convertComparator( comparator );

			referenceType = m_condset->at(conditionNumber)->returnReferenceType( subCondNumber, i );
			referenceTypeStr = convertReferenceType( referenceType );

			BOOL textRef = ((OrSubCondition*) (m_condset->at(conditionNumber)->
				at( subCondNumber )))->at(i)->textRef;

			if ( ! textRef )
			{
				referenceValue = m_condset->at(conditionNumber)->returnReferenceValue( subCondNumber, i );
				referenceValueStr.Format( _T("%.5g"), referenceValue );

				if( g_separatorComma )
					referenceValueStr.Replace( _T( "." ), _T( "," ) );
			}
			else
			{
				referenceValueStr = m_condset->at(conditionNumber)->returnReferenceValueText( subCondNumber, i );
			}


			m_gridAv.SetItemText( startLine+i, 0, columnStr );
			m_gridAv.SetItemText( startLine+i, 1, comparatorStr );
			m_gridAv.SetItemText( startLine+i, 3, referenceTypeStr );
			m_gridAv.SetItemText( startLine+i, 2, referenceValueStr );
			m_gridAv.setGridCheck( startLine+i, 4, textRef );

			m_gridAv.setGridRowPink( startLine+i, pinkType );
		}
	}

	m_gridAv.Refresh();
}

void CArtDlg::returnExpCondition( int conditionNumber )
{
	if( (conditionNumber < 0) || (conditionNumber > (m_condset->returnSize() - 1)) )
	{
		m_gridAv.SetRowCount( 1 ); // headline

		return;
	}
		
	int numberOfSubConditions = m_condset->at(conditionNumber)->returnNumberOfSubConds();
	int totalNumberOfLines = m_condset->at(conditionNumber)->returnNumberOfLines();
	m_gridAv.SetRowCount( totalNumberOfLines+1 );

	CString theString = m_condset->at( conditionNumber )->returnName( );
	m_editCondName.SetWindowText( theString );

	int columnAv = ( m_condset->at( conditionNumber )->retColumnAv() ) + 1;
	theString.Format( "%d", columnAv );
	m_editColumnAv.SetWindowText( theString );

	int lineFrom = ( m_condset->at( conditionNumber )->returnFirstLine( ) ) + 1;
	theString.Format( "%d", lineFrom );
	m_editLineFrom.SetWindowText( theString );

	int lineTo = ( m_condset->at( conditionNumber )->returnLastLine( ) ) + 1;

	BOOL specialAv = m_condset->at( conditionNumber )->retSpecialAv();
	BOOL popEst = m_condset->at( conditionNumber )->returnPopEst();
	BOOL fileEnd = m_condset->at( conditionNumber )->returnLineToFileEnd();

	m_checkSpecialAv.SetCheck( specialAv );
	m_checkPopEst.SetCheck( popEst );
	m_checkFileEnd.SetCheck( fileEnd );

	if( fileEnd )
		theString = _T( "" );
	else
		theString.Format( "%d", lineTo );
	
	m_editLineTo.SetWindowText( theString );


	int centTendency = m_condset->at( conditionNumber )->returnCentTendency( );
	setRadiosCentTendency( centTendency );

	updateAvFieldsEnDisabled( centTendency, specialAv, fileEnd );
	
	int startLine = 1;
	for (int i = 0; i < numberOfSubConditions; i++)
	{
		returnSubCondition( conditionNumber, i, startLine );
		startLine += m_condset->at(conditionNumber)->returnSubCondSize(i);
	}
}

void CArtDlg::setRadiosCentTendency( int centTendency )
{
	switch( centTendency )
	{
	case CENT_TEND_RAW:
			m_radioRawValues.SetCheck( 1 );
			m_radioMean.SetCheck( 0 );
			m_radioMedian.SetCheck( 0 );
			m_radioIncidences.SetCheck( 0 );
			m_radioSumme.SetCheck( 0 );
			m_radioVariance.SetCheck( 0 );
			m_radioStandardDeviation.SetCheck( 0 );
			break;	
	case CENT_TEND_MEAN:
			m_radioRawValues.SetCheck( 0 );
			m_radioMean.SetCheck( 1 );
			m_radioMedian.SetCheck( 0 );
			m_radioIncidences.SetCheck( 0 );
			m_radioSumme.SetCheck( 0 );
			m_radioVariance.SetCheck( 0 );
			m_radioStandardDeviation.SetCheck( 0 );
			break;
		case CENT_TEND_MEDIAN:
			m_radioRawValues.SetCheck( 0 );
			m_radioMean.SetCheck( 0 );
			m_radioMedian.SetCheck( 1 );
			m_radioIncidences.SetCheck( 0 );
			m_radioSumme.SetCheck( 0 );
			m_radioVariance.SetCheck( 0 );
			m_radioStandardDeviation.SetCheck( 0 );
			break;
		case CENT_TEND_INCIDENCES:
			m_radioRawValues.SetCheck( 0 );
			m_radioMean.SetCheck( 0 );
			m_radioMedian.SetCheck( 0 );
			m_radioIncidences.SetCheck( 1 );
			m_radioSumme.SetCheck( 0 );
			m_radioVariance.SetCheck( 0 );
			m_radioStandardDeviation.SetCheck( 0 );
			break;
		case CENT_TEND_SUM:
			m_radioRawValues.SetCheck( 0 );
			m_radioMean.SetCheck( 0 );
			m_radioMedian.SetCheck( 0 );
			m_radioIncidences.SetCheck( 0 );
			m_radioSumme.SetCheck( 1 );
			m_radioVariance.SetCheck( 0 );
			m_radioStandardDeviation.SetCheck( 0 );
			break;
		case CENT_TEND_VARIANCE:
			m_radioRawValues.SetCheck( 0 );
			m_radioMean.SetCheck( 0 );
			m_radioMedian.SetCheck( 0 );
			m_radioIncidences.SetCheck( 0 );
			m_radioSumme.SetCheck( 0 );
			m_radioVariance.SetCheck( 1 );
			m_radioStandardDeviation.SetCheck( 0 );
			break;
		case CENT_TEND_STANDDEV:
			m_radioRawValues.SetCheck( 0 );
			m_radioMean.SetCheck( 0 );
			m_radioMedian.SetCheck( 0 );
			m_radioIncidences.SetCheck( 0 );
			m_radioSumme.SetCheck( 0 );
			m_radioVariance.SetCheck( 0 );
			m_radioStandardDeviation.SetCheck( 1 );
			break;
	}
}


void CArtDlg::initGridAv(void)
{
	m_gridAv.SetEditable(true);
	m_gridAv.SetRowCount(2);
	m_gridAv.SetColumnCount(5);
	m_gridAv.SetFixedRowCount(1);

	m_gridAv.SetItemText( 0, 0, _T("column #") );
	m_gridAv.SetItemText( 0, 1, _T("operator") );
	m_gridAv.SetItemText( 0, 2, _T("reference") );
	m_gridAv.SetItemText( 0, 3, _T("ref. type") );
	m_gridAv.SetItemText( 0, 4, _T("as text") );
}

void CArtDlg::initGridUv(void)
{
	m_gridUv.SetEditable(true);
	
	m_gridUv.SetRowCount(2);
	m_gridUv.SetColumnCount(3);
	m_gridUv.SetFixedRowCount(1);

	m_gridUv.SetItemText( 0, 0, _T("name") );
	m_gridUv.SetItemText( 0, 1, _T("row #") );
	m_gridUv.SetItemText( 0, 2, _T("column #") );

	m_gridUv.SetItemText( 1, 1, _T("1") );
	m_gridUv.SetItemText( 1, 2, _T("1") );
}

void CArtDlg::initGridConds(void)
{
	m_gridConds.SetEditable(false);
	
	m_gridConds.SetRowCount(1);
	m_gridConds.SetColumnCount(1);
	m_gridConds.SetSelectedRange( 0, 0, 0, 0 );
}

void CArtDlg::initControls(void)
{
	m_spinConditionNumber.SetRange32( 1, m_numberOfConditions );
	m_spinConditionNumber.SetBuddy( &m_editConditionNumber );
	m_spinFileInPreview.SetBuddy( &m_editFileInPreview );
	
	m_radioMean.SetCheck( 1 );

	m_editConditionNumber.SetWindowTextA( _T( "1" ) );

	//UDACCEL accel;
	//accel.nSec = 0;
	//accel.nInc = 1;

	//m_spinConditionNumber.SetAccel( 1, &accel );

	m_checkTabs.SetCheck( BST_CHECKED );
	m_checkBlanks.SetCheck( BST_UNCHECKED );
	m_checkCR.SetCheck( BST_CHECKED );
	m_checkNewLine.SetCheck( BST_UNCHECKED );
	m_checkVertTab.SetCheck( BST_UNCHECKED );
	m_checkNewPage.SetCheck( BST_UNCHECKED );
}



void CArtDlg::OnDeltaposSpinCondNumber(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);

	// Capture condition just edited
	this->UpdateWindow();
	setExpCondition( m_actualConditionNumber );

	int actSpinPos = m_spinConditionNumber.GetPos32(); // *old* position of the spin control

	int lowRange, highRange;
	m_spinConditionNumber.GetRange32( lowRange, highRange );

	if( ((actSpinPos + pNMUpDown->iDelta) >= lowRange) && ((actSpinPos + pNMUpDown->iDelta) <= highRange) )
		actSpinPos += pNMUpDown->iDelta; 


	m_actualConditionNumber =  actSpinPos - 1;
	showCondition( m_actualConditionNumber, FALSE );

	*pResult = 0;
}

void CArtDlg::OnEnChangeEditCondNumber()
{
	// Capture condition just edited
	this->UpdateWindow();
	setExpCondition( m_actualConditionNumber );
	
	int actSpinPos = m_spinConditionNumber.GetPos32(); // *old* position of the spin control

	CString StringNewEditValue;
	m_editConditionNumber.GetWindowTextA( StringNewEditValue );

	int newEditValue = atoi( StringNewEditValue );

	int lowRange, highRange;
	m_spinConditionNumber.GetRange32( lowRange, highRange );

	if( newEditValue < lowRange)
		actSpinPos = lowRange;
	else if( newEditValue > highRange)
		actSpinPos = highRange;
	else
		actSpinPos = newEditValue;

	m_spinConditionNumber.SetPos32( actSpinPos );

	if( actSpinPos == 0 )
	{
		m_editConditionNumber.SetWindowTextA( _T( "" ) );
		m_editConditionNumber.SetReadOnly( TRUE );
	}
	else
	{
		m_editConditionNumber.SetReadOnly( FALSE );
	}


	m_actualConditionNumber =  actSpinPos - 1;
	showCondition( m_actualConditionNumber );
}

BOOL CArtDlg::checkInputFiles(void)
{
	if ( m_filenames.GetSize() > 0)
	{
		// Check whether protocol files still exist in that place
		for( int i = 0; i < m_filenames.GetSize( ); i++ )
		{
			FILE *file;
			// Check whether file exists.
			file = fopen ( m_filenames.GetAt( i ).GetBuffer( ), "r" );

			if( ! file )
			{
				m_filenames.RemoveAll( );
				
				CString message;
				message.Append( _T( "(Some of) the protocol files you chose in the last session\ndo not exist anymore (in that place).\nPlease select new protocol files." ) );
			
				MessageBox( message, _T("Caution"), MB_ICONSTOP | MB_OKCANCEL );

				return FALSE;
			}
			else
			{
				fclose( file );
			}
		}

		return TRUE;
	}
	else
	{
		MessageBox( _T("No protocol files selected!"), _T("Error"), MB_ICONSTOP );
		return FALSE;
	}
}

BOOL CArtDlg::checkOutputFiles(void)
{
	if ( m_outfile != "")
	{
		FILE *file = fopen ( m_outfile.GetBuffer( ), "r" );
		
		// Check whether output file already exists.
		if( file )
		{
			fclose( file );

			CString message;
			message.Append( _T( "File \'" ) );
			message.Append( m_outfile );
			message.Append( _T( "\' already exists. \nDo you wish to overwrite it?" ) );
			
			if( MessageBox( message, _T("Caution"), MB_ICONSTOP | MB_OKCANCEL ) != IDOK )
			{
				return FALSE;
			}
		}
		
		// Check whether file is opened by another application.
		FILE *pFile = fopen ( m_outfile.GetBuffer( ), "w");
		if ( !pFile )
		{
			CString message;
			message.Append( _T( "File \'" ) );
			message.Append( m_outfile );
			message.Append( _T( "\' is already opened by an other application.\nPlease close the file in that application and try again." ) );

			MessageBox( message, _T("Error"), MB_ICONSTOP );
			return FALSE;
		}
		else
		{
			fclose (pFile);
			return TRUE;
		}
	}
	else // m_outfile equal ""
	{
		MessageBox( _T("No output file defined!"), _T("Error"), MB_ICONSTOP );
		return FALSE;
	}

	return FALSE;
}

void CArtDlg::setUvs(void)
{
	m_uvSet->clear();
	CString name, rowStr, columnStr;
	int row, column;
	
	for (int line=1; line < m_gridUv.GetRowCount(); line++)
	{	
		name = m_gridUv.GetItemText( line, 0 );
		rowStr = m_gridUv.GetItemText( line, 1 );
		columnStr = m_gridUv.GetItemText( line, 2 );

		row = _tstof((LPCTSTR)rowStr); row--;
		column = _tstof((LPCTSTR)columnStr); column--;
		
		m_uvSet->addCondition( name.GetBuffer() );
		m_uvSet->at( line-1 )->setRowColumn( row, column );
	}
}

void CArtDlg::getUvs(void)
{
	CString name, rowStr, columnStr;
	m_gridUv.SetRowCount( m_uvSet->returnSize( ) + 1 );
	
	for(int i=0; i < m_uvSet->returnSize( ); i++)
	{
		name = m_uvSet->at( i )->returnName( );
		rowStr.Format( "%d", m_uvSet->at( i )->returnRow( ) + 1 );
		columnStr.Format( "%d", m_uvSet->at( i )->returnColumn( ) + 1 );

		m_gridUv.SetItemText( i+1, 0, name );
		m_gridUv.SetItemText( i+1, 1, rowStr );
		m_gridUv.SetItemText( i+1, 2, columnStr );
	}

	m_gridUv.Refresh( );
}

int CArtDlg::convertComparator(CString comparatorString)
{
		if ( comparatorString.Compare(_T("<")) == 0 )
		{
			return -2;
		}
		else if ( comparatorString.Compare(_T("<=")) == 0 )
		{
			return -1;
		}
		else if ( comparatorString.Compare(_T("=")) == 0 )
		{
			return 0;
		}
		else if ( comparatorString.Compare(_T(">=")) == 0 )
		{
			return 1;
		}
		else if ( comparatorString.Compare(_T(">")) == 0 )
		{
			return 2;
		}
		else if ( comparatorString.Compare(_T("<>")) == 0 )
		{
			return 10;
		}
		else if ( comparatorString.Compare(_T("equal sign")) == 0 )
		{
			return 20;
		}
		else if ( comparatorString.Compare(_T("unequal sign")) == 0 )
		{
			return 21;
		}
	
	return -99;
}

int CArtDlg::convertReferenceType( CString refTypeString )
{
	if( refTypeString.Compare( _T("constant") ) == 0 )
	{
		return 0;
	}
	else if( refTypeString.Compare( _T("column #") ) == 0 )
	{
		return 1;
	}

	return -1;
}

CString CArtDlg::convertComparator(int comparator)
{
	CString comparatorStr;
	
	switch (comparator)
	{
		case -2:
			comparatorStr = _T("<");
		break;
		case -1:
			comparatorStr = _T("<=");
		break;
		case 0:
			comparatorStr = _T("=");
		break;
		case 1:
			comparatorStr = _T(">=");
		break;
		case 2:
			comparatorStr = _T(">");
		break;
		case 10:
			comparatorStr = _T("<>");
		break;
		case 20:
			comparatorStr = _T("equal sign");
		break;
		case 21:
			comparatorStr = _T("unequal sign");
		break;
		default:
			comparatorStr = _T("-99");
		break;
	}
	
	return comparatorStr;
}

CString CArtDlg::convertReferenceType(int referenceType)
{
	CString referenceTypeStr;
	
	switch (referenceType)
	{
		case 0:
			referenceTypeStr = _T("constant");
		break;
		case 1:
			referenceTypeStr = _T("column #");
		break;
	}
	
	return referenceTypeStr;
}

void CArtDlg::OnGridEndSelChange(NMHDR *pNotifyStruct, LRESULT* /*pResult*/)
{
	/*NM_GRIDVIEW* pItem = (NM_GRIDVIEW*) pNotifyStruct;

	CGridCellCheck *pCell = (CGridCellCheck*) m_gridAv.GetCell(1,3);
	BOOL debug = pCell->GetCheck();*/
}

void CArtDlg::previewFile( int filenumber )
{
	if ( m_filenames.GetSize() > 0)
	{
		actProtocolFilenumber = filenumber;
		
		m_gridPreview.DeleteAllItems();
		
		CString buffer;
		buffer = m_filenames.GetAt( filenumber );


		WTextFile *theTextFile = new WTextFile( buffer.AllocSysString( ), m_crs, m_newLines, m_vertTabs, m_newPages, m_tabs, m_blanks );
		theTextFile->readFile( );

		applyProtocolFileChanges( theTextFile );


		m_numberOfRows = theTextFile->returnNumberOfLines( );
		m_numberOfCols = theTextFile->returnNumberOfColumns( );

		m_gridPreview.SetEditable( FALSE );
		m_gridPreview.SetRowCount( theTextFile->returnNumberOfLines( ) + 1 );
		m_gridPreview.SetColumnCount( m_numberOfCols + 1);
		m_gridPreview.SetFixedRowCount( 1 );
		m_gridPreview.SetFixedColumnCount( 1 );
		m_gridPreview.setFirstLineColor();

		CString numberStr;

		for ( int column=0; column < m_numberOfCols; column++ )
		{
			numberStr.Format( "%d", column+1 );
			m_gridPreview.SetItemText( 0, column+1, numberStr ); 
		}

		for ( int row=0; row < theTextFile->returnNumberOfLines( ); row++ )
		{
			numberStr.Format( "%d", row+1 );
			m_gridPreview.SetItemText( row+1, 0, numberStr ); 
		}


		for ( int row=0; row < theTextFile->returnNumberOfLines( ); row++ )
		{
			int column=0;
			while ( *theTextFile->at( row, column ) != L"\r" )
			{
				numberStr = theTextFile->at( row, column )->c_str( );
				m_gridPreview.SetItemText( row+1, column+1, numberStr );
				column++;
			}
		}
	
		delete theTextFile;

		//m_gridPreview.AutoSizeColumns( );
	}
}

void CArtDlg::OnBnClickedCheckTabs()
{
	m_tabs = m_checkTabs.GetCheck();

	previewFile();
}

void CArtDlg::OnBnClickedCheckBlanks()
{
	m_blanks = m_checkBlanks.GetCheck();

	previewFile();
}

void CArtDlg::OnBnClickedCheckCr()
{
	m_crs =  m_checkCR.GetCheck();

	previewFile();
}


void CArtDlg::OnBnClickedCheckNewLine()
{
	m_newLines = m_checkNewLine.GetCheck();

	previewFile();
}


void CArtDlg::OnBnClickedCheckVertTab()
{
	m_vertTabs = m_checkVertTab.GetCheck();

	previewFile();
}


void CArtDlg::OnBnClickedCheckNewPage()
{
	m_newPages = m_checkNewPage.GetCheck();

	previewFile();
}

void CArtDlg::OnBnClickedButtonAvFromPreview()
{	
	CCellID thePrevCell = m_gridPreview.GetFocusCell();
	CCellID theAvCell = m_gridAv.GetFocusCell();

	CString contentStr = m_gridPreview.GetItemText( thePrevCell.row, thePrevCell.col );
	CString columnStr; columnStr.Format( "%d", thePrevCell.col );

	m_gridAv.SetItemText( theAvCell.row, 0, columnStr );
	m_gridAv.SetItemText( theAvCell.row, 2, contentStr );

	m_gridAv.Refresh();
}

void CArtDlg::OnBnClickedButtonUvFromPreview()
{
	CCellID thePrevCell = m_gridPreview.GetFocusCell();
	CCellID theUvCell = m_gridUv.GetFocusCell();

	CString rowStr; rowStr.Format( "%d", thePrevCell.row );
	CString columnStr; columnStr.Format( "%d", thePrevCell.col );

	m_gridUv.SetItemText( theUvCell.row, 1, rowStr );
	m_gridUv.SetItemText( theUvCell.row, 2, columnStr );

	m_gridUv.Refresh();
}

void CArtDlg::refreshCondsGrid( BOOL selectCell )
{
	CString condName;
	m_gridConds.SetColumnCount( m_condset->returnSize( ) );

	if( m_condset->returnSize( ) > 0 )
	{
		for( int i=0; i < m_condset->returnSize( ); i++)
		{
			condName = m_condset->at( i )->returnName( );
			m_gridConds.SetItemText( 0, i, condName );

			CGridDefaultCell *theCell = (CGridDefaultCell*) m_gridConds.GetCell(0, i);

			theCell->SetBackClr(RGB(220, 220, 240));
		}
		
		if( (m_actualConditionNumber > -1) && (m_gridConds.GetColumnCount() > 1) )
		{
			if( selectCell )
				m_gridConds.SetSelectedRange( 0, m_actualConditionNumber, 0, m_actualConditionNumber );

			m_gridConds.EnsureVisible( 0, m_actualConditionNumber );
		}
		else
		{
			if( selectCell )
				m_gridConds.SetSelectedRange( 0, 0, 0, 0 );

			m_gridConds.EnsureVisible( 0, 0 );
		}
	}

	m_gridConds.Refresh( );
}

void CArtDlg::OnCondsGridClick( NMHDR *pNotifyStruct, LRESULT* /*pResult*/ )
{
	setExpCondition( m_actualConditionNumber );
	
	NM_GRIDVIEW* pItem = (NM_GRIDVIEW*) pNotifyStruct;

	if( ( pItem->iRow != 0 ) || ( pItem->iColumn < 0 ) )
		return;

	m_actualConditionNumber = pItem->iColumn;

	showCondition( m_actualConditionNumber );
	m_spinConditionNumber.SetPos32( m_actualConditionNumber + 1 );
}

BOOL CArtDlg::PreTranslateMessage( MSG* pMsg )
{
	if(m_hAccel)
	{
		if(::TranslateAccelerator(m_hWnd, m_hAccel, pMsg))
		return(TRUE);
	}

	if( pMsg->message == WM_KEYDOWN && pMsg->wParam == 13 ) // Return
	{
		setExpCondition( m_actualConditionNumber );
		refreshCondsGrid();

		// We must "leave" here, otherwise OnOK is called.
		return TRUE;
	}

	if( pMsg->message == WM_KEYDOWN && pMsg->wParam == 190 ) // point
	{
		if( g_separatorComma )
			pMsg->wParam = 188; // comma
	}
	else if( pMsg->message == WM_KEYDOWN && pMsg->wParam == 188 ) // comma
	{
		if( ! g_separatorComma )
			pMsg->wParam = 190; // point
	}

	// Always update everything  - on mouse click or keypress
	if( (pMsg->message == WM_LBUTTONUP) || (pMsg->message == WM_RBUTTONUP) /*|| (pMsg->message == WM_KEYUP)*/ )
	{
		setExpCondition( m_actualConditionNumber );
		refreshCondsGrid( FALSE );
	}

	return CDialog::PreTranslateMessage(pMsg);
}

void CArtDlg::OnFileOpen()
{
	CFileDialog fileDialog( TRUE, NULL, NULL,
		OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_ALLOWMULTISELECT,
		// In this string no unnecessary blanks are allowed!
		_T("ART-Files (*.art)|*.art|All Files (*.*)|*.*||"));

	fileDialog.m_ofn.lpstrTitle = "Open ART-file";
	

	if (fileDialog.DoModal() == IDOK)
	{
		CString strPath = fileDialog.GetPathName();
		openArtFile( strPath );

		CString windowTitle = fileDialog.GetFileName();
		windowTitle.Append( _T( " - ART" ) );
		this->SetWindowTextA( windowTitle );
	}

	previewFile();
}

void CArtDlg::openArtFile( CString filePath )
{
	if (filePath.Find(":\\\\") == 1 && filePath.GetLength() > 4)
		{
			// this means we have an invalid path that looks like this:
			// C:\\cda.dgl
			// get rid of extra slash
			CString temp;
			temp = filePath.Left(3);
			temp += filePath.Mid(4);
			filePath = temp;
		}

		// Let's get it ...
		CFile theFile;
		theFile.Open(filePath, CFile::modeRead);
		CArchive archive(&theFile, CArchive::load);

		Serialize( archive );

		archive.Close();
		theFile.Close();

		m_numberOfConditions = m_condset->returnSize( );
		m_numberOfUvs = m_uvSet->returnSize( );

		m_spinConditionNumber.SetRange32( 1, m_numberOfConditions );
		m_spinConditionNumber.RedrawWindow();
		m_actualConditionNumber = m_numberOfConditions - 1;

		m_actualConditionNumber = 0;
		returnExpCondition( m_actualConditionNumber );
		getUvs( );
		refreshCondsGrid( TRUE );

		m_artFilePath = filePath;
}


void CArtDlg::OnFileSave()
{
	if( m_artFilePath == _T("") )
		OnFileSaveas( );
	else
	{
		// Let's save it ...
		m_editConditionNumber.SetFocus(); // If the cursor is still positioned in a grid cell, the input procedure is terminated by the change of focus
		setExpCondition( m_actualConditionNumber );
		setUvs();
		
		CFile theFile;
		theFile.Open( m_artFilePath, CFile::modeCreate | CFile::modeWrite);
		CArchive archive(&theFile, CArchive::store);
		
		Serialize( archive );

		archive.Close();
		theFile.Close();

		m_somethingToSave = false;
	}
}

void CArtDlg::OnFileSaveas()
{
	CFileDialog fileDialog( FALSE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, _T("ART-Files (*.art)|*.art|All Files (*.*)|*.*||") );

	fileDialog.m_ofn.lpstrTitle = "Save ART-file";
	

	if (fileDialog.DoModal() == IDOK)
	{
		CString strPath = fileDialog.GetPathName();

		// append .art, if not already done.
		if( strPath.Right( 4 ) != _T(".art") )
			strPath += _T(".art");

		if (strPath.Find(":\\\\") == 1 && strPath.GetLength() > 4)
		{
			// this means we have an invalid path that looks like this:
			// C:\\cda.dgl
			// get rid of extra slash
			CString temp;
			temp = strPath.Left(3);
			temp += strPath.Mid(4);
			strPath = temp;
		}

		// Save it ...
		m_editConditionNumber.SetFocus(); // If the cursor is still positioned in a grid cell, the input procedure is terminated by the change of focus
		setExpCondition( m_actualConditionNumber );
		setUvs();
		
		CFile theFile;
		theFile.Open( strPath, CFile::modeCreate | CFile::modeWrite);
		CArchive archive(&theFile, CArchive::store);
		
		Serialize( archive );

		archive.Close();
		theFile.Close();

		m_artFilePath = strPath;
		m_somethingToSave = false;

		CString windowTitle = fileDialog.GetFileName();
		windowTitle.Append( _T( " - ART" ) );
		this->SetWindowTextA( windowTitle );
	}
}

void CArtDlg::OnUpdateSomethingToSave(CCmdUI *pCmdUI)
{
	/*pCmdUI->Enable( m_somethingToSave );*/
	pCmdUI->Enable( true );
}

void CArtDlg::OnEditCopySelection()
{
	// By changing the focus a possibly not terminated input procedure into the grid  is terminated.
	m_staticDelimiters.SetFocus();
	
	m_copyCondset->clear( );
	
	CCellRange theRange = m_gridConds.GetSelectedCellRange( );
	int from = theRange.GetMinCol( );
	int to = theRange.GetMaxCol( );

	for( int i = from; i <= to; i++ )
	{
		m_copyCondset->addCondition( m_condset->at( i ) );
	}
}

void CArtDlg::OnEditCutSelection()
{
	// By changing the focus a possibly not terminated input procedure into the grid  is terminated.
	m_staticDelimiters.SetFocus();
	
	if( m_numberOfConditions < 1 )
	{
		MessageBox( _T("Nothing to cut!"), _T("Error"), MB_ICONSTOP );
		return;
	}

	m_copyCondset->clear( );
	
	CCellRange theRange = m_gridConds.GetSelectedCellRange( );
	int from = theRange.GetMinCol( );
	int to = theRange.GetMaxCol( );

	for( int i = from; i <= to; i++ )
	{
		m_copyCondset->addCondition( m_condset->at( i ) );
	}

	for( int i = from; i <= to; i++ )
	{
		m_condset->deleteCondition( from );
		m_numberOfConditions--;
	}


	m_actualConditionNumber = from - 1;

	if( m_numberOfConditions > 0 )
	{
		m_spinConditionNumber.SetRange32( 1, m_numberOfConditions );
	}
	else
	{
		m_spinConditionNumber.SetRange32( 0, 0 );
	}

	m_spinConditionNumber.RedrawWindow();
	showCondition( m_actualConditionNumber );
}

void CArtDlg::OnUpdateCondsSelected(CCmdUI *pCmdUI)
{
	CCellRange theRange = m_gridConds.GetSelectedCellRange( );
	int from = theRange.GetMinCol( );
	int to = theRange.GetMaxCol( );

	BOOL somethingToCopy;

	if( (from > -1) && (to > -1) )
		somethingToCopy = true;
	else
		somethingToCopy = false;

	pCmdUI->Enable( somethingToCopy );
}

void CArtDlg::OnEditPasteSelection()
{
	// By changing the focus a possibly not terminated input procedure into the grid  is terminated.
	m_staticDelimiters.SetFocus();
	
	// Capture just edited condition
	if( m_actualConditionNumber > -1 )
		setExpCondition( m_actualConditionNumber );

	CCellID theID = m_gridConds.GetFocusCell( );

	int where = theID.col;
	int whereCopy = where + 1;
	for( int i=0; i < m_copyCondset->returnSize( ); i++ )
	{
		m_condset->insertCondition( whereCopy, m_copyCondset->at( i ) );
		m_numberOfConditions++;
		whereCopy++;
	}

	m_actualConditionNumber = whereCopy - 1;

	m_spinConditionNumber.SetRange32( 1, m_numberOfConditions );
	m_spinConditionNumber.RedrawWindow();

	// Show the chosen condition
	showCondition( m_actualConditionNumber );
}

void CArtDlg::OnUpdateCondsToPaste(CCmdUI *pCmdUI)
{
	BOOL conditionInCopyCondset;

	if( m_copyCondset->returnSize( ) > 0 )
		conditionInCopyCondset = true;
	else
		conditionInCopyCondset = false;
	
	pCmdUI->Enable( conditionInCopyCondset );
}

void CArtDlg::OnEditAppendSelection()
{
	// By changing the focus a possibly not terminated input procedure into the grid  is terminated.
	m_staticDelimiters.SetFocus();
	
	// Capture just edited condition
	setExpCondition( m_actualConditionNumber );

	CCellRange theRange = m_gridConds.GetSelectedCellRange( );
	int from = theRange.GetMinCol( );
	int to = theRange.GetMaxCol( );

	int where = m_numberOfConditions;

	for (int i = from; i <= to; i++)
	{
		m_condset->copyCondition( i );
		m_numberOfConditions++;
	}

	m_actualConditionNumber = where; // The first 'copied condition' will be displayed

	m_spinConditionNumber.SetRange32( 1, m_numberOfConditions );
	m_spinConditionNumber.RedrawWindow();

	// Show the chosen condition
	showCondition( m_actualConditionNumber );
}

void CArtDlg::OnWithinSubjectsInsertRule()
{
	setExpCondition( m_actualConditionNumber );

	CCellID theAvCell = m_gridAv.GetFocusCell();
	int row = theAvCell.row;

	if( row > -1 )
		m_condset->at( m_actualConditionNumber )->insertSubCondition( ((m_condset->at( m_actualConditionNumber )->returnSubCondFromPos( row-1 )) + 1 ), 0, 0, 1 );
	else
		m_condset->at( m_actualConditionNumber )->addSubCondition( 0, 0, 1 );

	
	returnExpCondition( m_actualConditionNumber );
}

void CArtDlg::OnUpdateCondsAvailable(CCmdUI *pCmdUI)
{
	if( m_actualConditionNumber > -1 )
		pCmdUI->Enable( true );
	else
		pCmdUI->Enable( false );
}

void CArtDlg::OnWithinSubjectsInsertOrBlock()
{
	setExpCondition( m_actualConditionNumber );

	CCellID theAvCell = m_gridAv.GetFocusCell();
	int row = theAvCell.row;

	if( row > -1 )
		m_condset->at( m_actualConditionNumber )->insertOrSubCondition( (m_condset->at( m_actualConditionNumber )->returnSubCondFromPos( row-1 )) + 1 );
	else
		m_condset->at( m_actualConditionNumber )->addOrSubCondition();

	returnExpCondition( m_actualConditionNumber );
}

void CArtDlg::OnWithinSubjectsDeleteRule()
{
	setExpCondition( m_actualConditionNumber );
	
	if (m_condset->at( m_actualConditionNumber )->returnSize() > 0)
	{
		m_condset->at( m_actualConditionNumber )->deleteLastSubCondition();
	}
	
	returnExpCondition( m_actualConditionNumber );
}

void CArtDlg::OnWithinSubjectsAddCondition()
{	
	// Terminate any unterminated input into the grid by changing the focus.
	m_staticDelimiters.SetFocus();
	
	// Capture just edited condition
	setExpCondition( m_actualConditionNumber );

	if( m_condset->returnSize() < 1 )
	{
		m_condset->addCondition( "" );
	}
	else
	{
		m_condset->copyConditionMinimal( m_actualConditionNumber );
	}

	m_actualConditionNumber++;
	m_numberOfConditions++;

	m_spinConditionNumber.SetRange32( 1, m_numberOfConditions );
	m_spinConditionNumber.RedrawWindow();
	
	// Show chosen condition
	showCondition( m_actualConditionNumber );
}

void CArtDlg::OnWithinSubjectsCopyCondition()
{
	// Terminate any unterminated input into the grid by changing the focus.
	m_staticDelimiters.SetFocus();
	
	// Capture just edited condition
	setExpCondition( m_actualConditionNumber );

	if( m_condset->returnSize() < 1 )
	{
		m_condset->addCondition( "" );
	}
	else
	{
		m_condset->copyCondition( m_actualConditionNumber + 1, m_actualConditionNumber );
	}

	m_actualConditionNumber++;
	m_numberOfConditions++;

	m_spinConditionNumber.SetRange32( 1, m_numberOfConditions );
	m_spinConditionNumber.RedrawWindow();
	
	// Show chosen condition
	showCondition( m_actualConditionNumber );
}

void CArtDlg::OnWithinSubjectsDeleteCondition()
{
	// Terminate any unterminated input into the grid by changing the focus.
	m_staticDelimiters.SetFocus();
	
	if( m_numberOfConditions < 1 )
	{
		MessageBox( _T("Nothing to cut!"), _T("Error"), MB_ICONSTOP );
		return;
	}

	
	CCellRange theRange = m_gridConds.GetSelectedCellRange( );
	int from = theRange.GetMinCol( );
	int to = theRange.GetMaxCol( );


	for( int i = from; i <= to; i++ )
	{
		m_condset->deleteCondition( from );
		m_numberOfConditions--;
	}


	m_actualConditionNumber = from - 1;

	if( m_actualConditionNumber < 0 )
		m_actualConditionNumber = 0;


	if( m_numberOfConditions > 0 )
	{
		m_spinConditionNumber.SetRange32( 1, m_numberOfConditions );
	}
	else
	{
		m_spinConditionNumber.SetRange32( 0, 0 );
	}

	m_spinConditionNumber.RedrawWindow();
	showCondition( m_actualConditionNumber );
}

void CArtDlg::OnWithinSubjectsInsertLine()
{
	setExpCondition( m_actualConditionNumber );

	CCellID theCell = m_gridAv.GetFocusCell();

	int row = theCell.row;
	int column = theCell.col;

	if (row < 0)
	{
		row = m_gridAv.GetRowCount() - 1;
	}


	int subcond = m_condset->at( m_actualConditionNumber )->returnSubCondFromPos( row-1 );
	int relPos = m_condset->at( m_actualConditionNumber )->returnRelFromAbsPos( row-1 );

	if( (row < 0) || (column < 0) ) // if there is no Subcondition, then create one of normal type
	{
		m_condset->at( m_actualConditionNumber )->insertSubCondition( subcond+1, 0, 0, 1 );
		returnExpCondition( m_actualConditionNumber );
		return;
	}


	if ( m_condset->at( m_actualConditionNumber )->at(subcond)->orType )
	{
		((OrSubCondition*)(m_condset->at( m_actualConditionNumber )->at(subcond)))->insertSubCondition(relPos+1, 0, 0, 1 );
	}
	else
	{
		m_condset->at( m_actualConditionNumber )->insertSubCondition( subcond+1, 0, 0, 1 );
	}

	
	returnExpCondition( m_actualConditionNumber );
}

void CArtDlg::OnWithinSubjectsDeleteLine( int row )
{
	setExpCondition( m_actualConditionNumber );

	if (row < 0)
	{
		row = m_gridAv.GetRowCount() - 1;
	}

	int subcond = m_condset->at( m_actualConditionNumber )->returnSubCondFromPos( row-1 );
	int relPos = m_condset->at( m_actualConditionNumber )->returnRelFromAbsPos( row-1 );

	if (m_condset->at( m_actualConditionNumber )->at(subcond)->orType)
	{
		((OrSubCondition*)(m_condset->at( m_actualConditionNumber )->at(subcond)))->
			deleteSubCondition(relPos);

		// If the OR-Subcondition consists of only one Subcondition, copy its content into a normal Subcondition and delete it ...
		if( ((OrSubCondition*)(m_condset->at( m_actualConditionNumber )->at(subcond)))->returnSize( ) == 1 )
		{
			int oldColumn = ((OrSubCondition*)(m_condset->at( m_actualConditionNumber )->at(subcond)))->at(0)->column + 1;
			int oldComparator = ((OrSubCondition*)(m_condset->at( m_actualConditionNumber )->at(subcond)))->at(0)->comparator;
			int oldRefType = ((OrSubCondition*)(m_condset->at( m_actualConditionNumber )->at(subcond)))->at(0)->referenceType;
			double oldRefValue = ((OrSubCondition*)(m_condset->at( m_actualConditionNumber )->at(subcond)))->at(0)->referenceValue;
			BOOL oldTextRef = ((OrSubCondition*)(m_condset->at( m_actualConditionNumber )->at(subcond)))->at(0)->textRef;
			CString oldRefValueText = ((OrSubCondition*)(m_condset->at( m_actualConditionNumber )->at(subcond)))->at(0)->referenceValueText;

			//((OrSubCondition*)(m_condset->at( m_actualConditionNumber )->at(subcond)))->deleteSubCondition( 0 );
			m_condset->at( m_actualConditionNumber )->deleteSubCondition( subcond );
			m_condset->at( m_actualConditionNumber )->insertSubCondition( subcond, 0, 0, 1 );

			if( oldTextRef )
			{
				m_condset->at( m_actualConditionNumber )->at(subcond)->textRef = true;
				m_condset->at( m_actualConditionNumber )->replaceSubCondition( subcond, oldColumn-1, oldComparator, oldRefValueText, oldRefType );
			}
			else
			{
				m_condset->at( m_actualConditionNumber )->at(subcond)->textRef = false;
				m_condset->at( m_actualConditionNumber )->replaceSubCondition( subcond, oldColumn-1, oldComparator, oldRefValue, oldRefType );
			}
		}

	}
	else
	{
		m_condset->at( m_actualConditionNumber )->deleteSubCondition( subcond);
	}
	

	returnExpCondition( m_actualConditionNumber );
}

void CArtDlg::OnWithinSubjectsDeleteLines()
{
	if ( m_gridAv.GetRowCount() < 2)
	{
		MessageBox( _T("Nothing to delete!"), _T("Error"), MB_ICONSTOP );
		return;
	}
	
	CCellRange theRange = m_gridAv.GetSelectedCellRange( );
	int from = theRange.GetMinRow( );
	int to = theRange.GetMaxRow( );

	if( (from < 0) || ( to < 0 ) )
		MessageBox( _T("You did not select a line to delete."), _T("Error"), MB_ICONSTOP );


	for( int row = to; row >= from; row-- )
	{
		OnWithinSubjectsDeleteLine( row );
	}

}

void CArtDlg::OnUpdateAvLinesSelected(CCmdUI *pCmdUI)
{
	CCellRange theRange = m_gridAv.GetSelectedCellRange( );
	int from = theRange.GetMinRow( );
	int to = theRange.GetMaxRow( );

	BOOL somethingToDelete;

	if( (from > -1) && ( to > -1 ) )
		somethingToDelete = true;
	else
		somethingToDelete = false;

	pCmdUI->Enable( somethingToDelete );
}

void CArtDlg::OnFileSelectInputFiles()
{
	m_filenames.RemoveAll();
	
	MultiFileDialog fileDialog( TRUE, NULL, NULL,
		OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_ALLOWMULTISELECT,
		// In this string no unnecessary blanks are allowed!
		_T("Text-Files (*.txt)|*.txt|All Files (*.*)|*.*||"));

	fileDialog.m_ofn.lpstrTitle = "Select protocol file(s)";
	
	if (fileDialog.DoModal() == IDOK)
	{
		POSITION pos = fileDialog.GetStartPosition();
		while (pos != NULL)
		{
			CString strPath = fileDialog.GetNextPathName(pos);
			if (strPath.Find(":\\\\") == 1 && strPath.GetLength() > 4)
			{
				// this means we have an invalid path that looks like this:
				// C:\\cda.dgl
				// get rid of extra slash
				CString temp;
				temp = strPath.Left(3);
				temp += strPath.Mid(4);
				strPath = temp;
			}
			
			m_filenames.Add( strPath );
		}
	}

	if( m_filenames.GetSize() > 0 )
	{
		m_editFileInPreview.EnableWindow( TRUE );
		m_spinFileInPreview.EnableWindow( TRUE );
		m_spinFileInPreview.SetRange32( 1, m_filenames.GetSize() );
		m_spinFileInPreview.SetPos32( 1 );
		previewFile();
	}
	else
	{
		m_editFileInPreview.EnableWindow( FALSE );
		m_spinFileInPreview.EnableWindow( FALSE );
	}

	CString textSelected;
	textSelected.Format( _T( "of %d protocol file" ), m_filenames.GetSize() );

	if( m_filenames.GetSize() != 1 )
		textSelected.Append( "s" );

	m_staticProtocolsSelected.SetWindowTextA( textSelected );
}


void CArtDlg::OnFileSelectOutputFile()
{
	CFileDialog fileDialog( FALSE, NULL, NULL, OFN_HIDEREADONLY /*| OFN_OVERWRITEPROMPT*/, _T("Text-Files (*.txt)|*.txt|All Files (*.*)|*.*||") );
	
	//CFileDialog fileDialog( FALSE, NULL, NULL,
	//	OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_ALLOWMULTISELECT,
	//	// In this string no unnecessary blanks are allowed!
	//	_T("All Files (*.*)|*.*|Text Files (*.txt)|*.txt||"));

	fileDialog.m_ofn.lpstrTitle = "Define output file";
	

	if (fileDialog.DoModal() == IDOK)
	{
		m_outfile = fileDialog.GetPathName();

		// Append .txt, if not already done.
		if( m_outfile.Right( 4 ) != _T(".txt") )
			m_outfile += _T(".txt");

		if (m_outfile.Find(":\\\\") == 1 && m_outfile.GetLength() > 4)
		{
			// this means we have an invalid path that looks like this:
			// C:\\cda.dgl
			// get rid of extra slash
			CString temp;
			temp = m_outfile.Left(3);
			temp += m_outfile.Mid(4);
			m_outfile = temp;
		}
	}
}

void CArtDlg::OnFileQuit()
{
	OnOK( );
}

void CArtDlg::OnBetweenSubjectsAddLine()
{
	CCellID theCell = m_gridUv.GetFocusCell();
	int selRow = theCell.row; // starts with 1 (not 0)
	int oldNumberOfRows = m_gridUv.GetRowCount() - 1; // The head line is taken into account by GridCtrl.

	if( selRow == -1 )
		selRow = oldNumberOfRows;

	m_gridUv.SetRowCount( m_gridUv.GetRowCount() + 1 );
	m_numberOfUvs++;

	for( int row = oldNumberOfRows; row > selRow; row-- )
	{
		m_gridUv.SetItemText( row+1, 0, m_gridUv.GetItemText( row, 0 ) );
		m_gridUv.SetItemText( row+1, 1, m_gridUv.GetItemText( row, 1 ) );
		m_gridUv.SetItemText( row+1, 2, m_gridUv.GetItemText( row, 2 ) );
	}
	
	m_gridUv.SetItemText( selRow+1, 0, _T("") );
	m_gridUv.SetItemText( selRow+1, 1, _T("1") );
	m_gridUv.SetItemText( selRow+1, 2, _T("1") );
}

void CArtDlg::OnBetweenSubjectsDeleteLine( int theRow )
{
	int oldNumberOfRows = m_gridUv.GetRowCount() - 1; // The head line is taken into account by GridCtrl.

	if( theRow == -1 )
		theRow = oldNumberOfRows;

	for( int row = theRow + 1; row <= oldNumberOfRows; row++ )
	{
		m_gridUv.SetItemText( row-1, 0, m_gridUv.GetItemText( row, 0 ) );
		m_gridUv.SetItemText( row-1, 1, m_gridUv.GetItemText( row, 1 ) );
		m_gridUv.SetItemText( row-1, 2, m_gridUv.GetItemText( row, 2 ) );
	}

	m_gridUv.SetRowCount( m_gridUv.GetRowCount() - 1 );
	m_numberOfUvs--;
}

void CArtDlg::OnBetweenSubjectsDeleteLines()
{
	if ( m_gridUv.GetRowCount() < 2)
	{
		MessageBox( _T("Nothing to delete!"), _T("Error"), MB_ICONSTOP );
		return;
	}
	
	CCellRange theRange = m_gridUv.GetSelectedCellRange( );
	int from = theRange.GetMinRow( );
	int to = theRange.GetMaxRow( );

	if( (from < 0) || ( to < 0 ) )
		MessageBox( _T("You did not select a line to delete."), _T("Error"), MB_ICONSTOP );


	for( int row = to; row >= from; row-- )
	{
		OnBetweenSubjectsDeleteLine( row );
	}

}

void CArtDlg::OnUpdateUvLinesSelected(CCmdUI *pCmdUI)
{
	CCellRange theRange = m_gridUv.GetSelectedCellRange( );
	int from = theRange.GetMinRow( );
	int to = theRange.GetMaxRow( );

	if( (from > -1) && ( to > -1 ) )
		pCmdUI->Enable( true );
	else
		pCmdUI->Enable( false );
}

void CArtDlg::OnBnClickedRadioRawValues()
{
	setRadiosCentTendency( CENT_TEND_RAW );
	updateAvFieldsEnDisabled( CENT_TEND_RAW, m_checkSpecialAv.GetCheck(), m_checkFileEnd.GetCheck() );
	m_checkPopEst.SetCheck( FALSE );
}

void CArtDlg::OnBnClickedRadioMean()
{
	setRadiosCentTendency( CENT_TEND_MEAN );
	updateAvFieldsEnDisabled( CENT_TEND_MEAN, m_checkSpecialAv.GetCheck(), m_checkFileEnd.GetCheck() );
	m_checkPopEst.SetCheck( FALSE );
}

void CArtDlg::OnBnClickedRadioMedian()
{
	setRadiosCentTendency( CENT_TEND_MEDIAN );
	updateAvFieldsEnDisabled( CENT_TEND_MEDIAN, m_checkSpecialAv.GetCheck(), m_checkFileEnd.GetCheck() );
	m_checkPopEst.SetCheck( FALSE );
}

void CArtDlg::OnBnClickedRadioIncidences()
{
	setRadiosCentTendency( CENT_TEND_INCIDENCES );
	updateAvFieldsEnDisabled( CENT_TEND_INCIDENCES, m_checkSpecialAv.GetCheck(), m_checkFileEnd.GetCheck() );
	m_checkPopEst.SetCheck( FALSE );
}

void CArtDlg::OnBnClickedRadioSumme()
{
	setRadiosCentTendency( CENT_TEND_SUM );
	updateAvFieldsEnDisabled( CENT_TEND_SUM, m_checkSpecialAv.GetCheck(), m_checkFileEnd.GetCheck() );
	m_checkPopEst.SetCheck( FALSE );
}

void CArtDlg::OnBnClickedRadioVariance()
{
	setRadiosCentTendency( CENT_TEND_VARIANCE );
	updateAvFieldsEnDisabled( CENT_TEND_VARIANCE, m_checkSpecialAv.GetCheck(), m_checkFileEnd.GetCheck() );
	m_checkPopEst.SetCheck( TRUE );
}


void CArtDlg::OnBnClickedRadioStandardDeviation()
{
	setRadiosCentTendency( CENT_TEND_STANDDEV );
	updateAvFieldsEnDisabled( CENT_TEND_STANDDEV, m_checkSpecialAv.GetCheck(), m_checkFileEnd.GetCheck() );
	m_checkPopEst.SetCheck( TRUE );
}


void CArtDlg::OnBnClickedCheckPopulationEstimation()
{
}



BOOL CArtDlg::OnEraseBkgnd(CDC* pDC)
{
	return CDialog::OnEraseBkgnd( pDC );
}

void CArtDlg::OnDestroy()
{
	if(m_pBitmap != NULL)
    {
        m_pMemDC->SelectObject(m_pOldBitmap);
        delete m_pBitmap;
    }
    if(m_pMemDC != NULL)
    {
       delete m_pMemDC;
    }
}

void CArtDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	positionDialogControls();
}

void CArtDlg::positionDialogControls()
{
	if(IsIconic() || !IsWindow( m_gridPreview ) || !IsWindow( m_gridConds ) || !IsWindow( m_gridAv ) || !IsWindow( m_gridUv ) )	
	{
		return;
	}


	CRect theRect;
	this->GetWindowRect( &theRect );
	ScreenToClient( &theRect );

	m_width = theRect.right - theRect.left;
	m_height = theRect.bottom - theRect.top;


	double scaFa = (double)m_dpiX / 96.0f;

	int leftBorder = 10 * scaFa;
	int rightBorder = 25 * scaFa;
	int topBorder = 10 * scaFa;
	int bottomBorder = 70 * scaFa;

	
	HDWP hdwp = BeginDeferWindowPos( 43 );

	int deltaX = 0;
	int deltaY = 0;

	int xSize = 75 * scaFa; int ySize = 23 * scaFa;
	DeferWindowPos( hdwp, m_buttonStart, NULL, m_width - rightBorder - xSize, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER );

	xSize = 70 * scaFa; ySize = 20 * scaFa; deltaX = 465 * scaFa; deltaY = 0 * scaFa;
	DeferWindowPos(hdwp, m_radioRawValues, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	deltaY += 25 * scaFa;

	xSize = 75 * scaFa; ySize = 23 * scaFa; deltaX = 180 * scaFa;
	DeferWindowPos(hdwp, m_staticWithinSubjects, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 70 * scaFa; ySize = 20 * scaFa; deltaX = 465 * scaFa;
	DeferWindowPos(hdwp, m_radioVariance, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 110 * scaFa; ySize = 20 * scaFa; deltaX = 540 * scaFa;
	DeferWindowPos(hdwp, m_radioStandardDeviation, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 120 * scaFa; ySize = 20 * scaFa; deltaX = 660* scaFa;
	DeferWindowPos(hdwp, m_checkPopEst, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 100 * scaFa; ySize = 20 * scaFa; deltaX = 85 * scaFa;
	DeferWindowPos(hdwp, m_staticBetweenSubjects, NULL, m_width - rightBorder - deltaX - xSize, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	deltaY += 25 * scaFa;

	xSize = 50 * scaFa; ySize = 20 * scaFa; deltaX = 465 * scaFa;
	DeferWindowPos(hdwp, m_radioMean, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 50 * scaFa; ySize = 20 * scaFa; deltaX = 525 * scaFa;
	DeferWindowPos(hdwp, m_radioMedian, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 80 * scaFa; ySize = 20 * scaFa; deltaX = 595 * scaFa;
	DeferWindowPos(hdwp, m_radioIncidences, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 40 * scaFa; ySize = 20 * scaFa; deltaX = 690 * scaFa;
	DeferWindowPos(hdwp, m_radioSumme, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	deltaY += 10 * scaFa;

	xSize = 454 * scaFa; ySize = 170 * scaFa;
	DeferWindowPos(hdwp, m_gridAv, NULL, leftBorder, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 294 * scaFa; ySize = 170 * scaFa; deltaX = 0 * scaFa;
	DeferWindowPos(hdwp, m_gridUv, NULL, m_width - rightBorder - deltaX - xSize, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	deltaY += 30 * scaFa;

	xSize = 50 * scaFa; ySize = 20 * scaFa; deltaX = 465 * scaFa;
	DeferWindowPos(hdwp, m_staticLineFrom, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 60 * scaFa; ySize = 20 * scaFa; deltaX = 520 * scaFa;
	DeferWindowPos(hdwp, m_editLineFrom, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 20 * scaFa; ySize = 20 * scaFa; deltaX = 600 * scaFa;
	DeferWindowPos(hdwp, m_staticLineTo, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 60 * scaFa; ySize = 20 * scaFa; deltaX = 625 * scaFa;
	DeferWindowPos(hdwp, m_editLineTo, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 50 * scaFa; ySize = 20 * scaFa; deltaX = 700 * scaFa;
	DeferWindowPos(hdwp, m_checkFileEnd, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	deltaY += 40 * scaFa;

	xSize = 70 * scaFa; ySize = 20 * scaFa; deltaX = 465 * scaFa;
	DeferWindowPos(hdwp, m_staticColumnAv, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 80 * scaFa; ySize = 20 * scaFa; deltaX = 540 * scaFa;
	DeferWindowPos(hdwp, m_editColumnAv, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 80 * scaFa; ySize = 20 * scaFa; deltaX = 630 * scaFa;
	DeferWindowPos(hdwp, m_checkSpecialAv, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 80 * scaFa; ySize = 20 * scaFa; deltaX = 710 * scaFa;
	DeferWindowPos(hdwp, m_buttonOptions, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	deltaY += 40 * scaFa;

	xSize = 50 * scaFa; ySize = 20 * scaFa; deltaX = 465 * scaFa;
	DeferWindowPos(hdwp, m_staticName, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 80 * scaFa; ySize = 20 * scaFa; deltaX = 540 * scaFa;
	DeferWindowPos(hdwp, m_editCondName, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	deltaY += 40 * scaFa;

	xSize = 50 * scaFa; ySize = 20 * scaFa; deltaX = 465 * scaFa;
	DeferWindowPos(hdwp, m_staticConditionNumber, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 80 * scaFa; ySize = 20 * scaFa; deltaX = 540 * scaFa;
	DeferWindowPos(hdwp, m_editConditionNumber, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 20 * scaFa; ySize = 20 * scaFa; deltaX = 620 * scaFa;
	DeferWindowPos(hdwp, m_spinConditionNumber, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	deltaY += 30 * scaFa;

	xSize = 100 * scaFa; ySize = 20 * scaFa; deltaX = 195 * scaFa;
	DeferWindowPos(hdwp, m_buttonFromPreview, NULL, m_width - rightBorder - deltaX - xSize, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 100 * scaFa; ySize = 20 * scaFa; deltaX = 195 * scaFa;
	DeferWindowPos(hdwp, m_buttonWithinFromPreview, NULL, leftBorder, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	deltaY += 30 * scaFa;

	xSize = (m_width - leftBorder - rightBorder); ySize = 45 * scaFa; deltaX = 195 * scaFa;
	DeferWindowPos(hdwp, m_gridConds, NULL, leftBorder, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	deltaY += 50 * scaFa;

	xSize = 80 * scaFa; ySize = 30 * scaFa; deltaX = 195 * scaFa;
	DeferWindowPos(hdwp, m_staticDelimiters, NULL, leftBorder, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 40 * scaFa; ySize = 30 * scaFa; deltaX = 100 * scaFa;
	DeferWindowPos(hdwp, m_staticVertical, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 90 * scaFa; ySize = 30 * scaFa; deltaX = 170 * scaFa; deltaY += 8 * scaFa;
	DeferWindowPos(hdwp, m_checkCR, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 85 * scaFa; ySize = 30 * scaFa; deltaX = 280 * scaFa;
	DeferWindowPos(hdwp, m_checkNewLine, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 95 * scaFa; ySize = 30 * scaFa; deltaX = 385 * scaFa;
	DeferWindowPos(hdwp, m_checkVertTab, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 87 * scaFa; ySize = 30 * scaFa; deltaX = 497 * scaFa;
	DeferWindowPos(hdwp, m_checkNewPage, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 50 * scaFa; ySize = 30 * scaFa; deltaX = 620 * scaFa; deltaY -= 8 * scaFa;
	DeferWindowPos(hdwp, m_staticHorizontal, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 60 * scaFa; ySize = 30 * scaFa; deltaX = 720 * scaFa; deltaY += 8 * scaFa;
	DeferWindowPos(hdwp, m_checkTabs, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 82 * scaFa; ySize = 30 * scaFa; deltaX = 798 * scaFa;
	DeferWindowPos(hdwp, m_checkBlanks, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 30 * scaFa; ySize = 30 * scaFa; deltaX = 950 * scaFa; deltaY -= 8 * scaFa;
	DeferWindowPos(hdwp, m_staticFile, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 50 * scaFa; ySize = 20 * scaFa; deltaX = 980 * scaFa; deltaY += 12 * scaFa;
	DeferWindowPos(hdwp, m_editFileInPreview, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 20 * scaFa; ySize = 20 * scaFa; deltaX = 1030 * scaFa;
	DeferWindowPos(hdwp, m_spinFileInPreview, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = 120 * scaFa; ySize = 20 * scaFa; deltaX = 1070 * scaFa;
	DeferWindowPos(hdwp, m_staticProtocolsSelected, NULL, leftBorder + deltaX, m_height - bottomBorder - ySize - deltaY, xSize, ySize, SWP_NOZORDER);

	xSize = (m_width - leftBorder - rightBorder); ySize = m_height - 440 * scaFa; deltaX = 195 * scaFa;
	DeferWindowPos(hdwp, m_gridPreview, NULL, leftBorder, topBorder, xSize, ySize, SWP_NOZORDER);

	EndDeferWindowPos( hdwp );
	Invalidate( );
}

void CArtDlg::OnSizing(UINT fwSide, LPRECT pRect)
{
	CDialog::OnSizing(fwSide, pRect);
}



void CArtDlg::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
{
	double scaFa = (double)m_dpiX / 96.0f;

	lpMMI->ptMinTrackSize.x = 1220 * scaFa;
	lpMMI->ptMinTrackSize.y = 800 * scaFa;

	CDialog::OnGetMinMaxInfo(lpMMI);
}

void CArtDlg::OnBnClickedOptions()
{
	m_specialAvDlg->getComputedAv( m_condset->at( m_actualConditionNumber )->retComputedAv() );
	m_specialAvDlg->DoModal();
}	

void CArtDlg::OnBnClickedCheckSpecialAv()
{
	m_buttonOptions.EnableWindow(  m_checkSpecialAv.GetCheck() );
	m_editColumnAv.EnableWindow(  ! m_checkSpecialAv.GetCheck() );
}

void CArtDlg::updateAvFieldsEnDisabled( int centTendency, BOOL specialAv, BOOL fileEnd )
{
	if( centTendency == 2 ) // # incidences
	{
		m_editColumnAv.EnableWindow( FALSE );
		m_checkSpecialAv.EnableWindow( FALSE );
		m_buttonOptions.EnableWindow( FALSE );
		m_checkPopEst.EnableWindow( FALSE );
	}
	else // not # incidences
	{
		m_editColumnAv.EnableWindow( ! specialAv );
		m_checkSpecialAv.EnableWindow( TRUE );
		m_buttonOptions.EnableWindow( specialAv );

		if( (centTendency == 4) || (centTendency == 5) ) // variance or standard deviation
			m_checkPopEst.EnableWindow( TRUE );
		else
			m_checkPopEst.EnableWindow( FALSE );
	}

	m_editLineTo.EnableWindow( ! fileEnd );
}

void CArtDlg::OnStnClickedStaticName()
{
}


////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////// Windows standard edit menu ////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////

//  handles menu updates
void CArtDlg::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu)
{
	if (bSysMenu)
		return;     // don't support system menu
	
	
	ASSERT(pPopupMenu != NULL);
	// check the enabled state of various menu items
	
	CCmdUI CmdUIState;
	CmdUIState.m_pMenu = pPopupMenu;

	ASSERT(CmdUIState.m_pOther == NULL);
	ASSERT(CmdUIState.m_pParentMenu == NULL); 
	
	// determine if menu is a popup in top-level menu and set m_pOther to
	//  it if so (m_pParentMenu == NULL indicates that it is secondary popup)
	CMenu* pTopMenu = GetMenu();
	ASSERT(pTopMenu != NULL);

// cannot use CMenu to comapre pointers, since 

	int nIndexMax = pTopMenu->GetMenuItemCount();
	for(int nIndex = 0; nIndex < nIndexMax; nIndex++)
	{
		CMenu* pDlgPopupMenu = pTopMenu->GetSubMenu(nIndex);
		//ASSERT(pDlgPopupMenu != NULL);

		if(pDlgPopupMenu == pPopupMenu)
		{
			// when popup is found, m_pParentMenu is containing menu
			CmdUIState.m_pParentMenu = pDlgPopupMenu;
			break;
		}
	}
	
	CmdUIState.m_nIndexMax = pPopupMenu->GetMenuItemCount();

	for (CmdUIState.m_nIndex = 0; CmdUIState.m_nIndex < CmdUIState.m_nIndexMax; CmdUIState.m_nIndex++)
	{
		CmdUIState.m_nID = pPopupMenu->GetMenuItemID(CmdUIState.m_nIndex);
		
		if (CmdUIState.m_nID == 0)
			continue; // separator 
		
		ASSERT(CmdUIState.m_pOther == NULL);
		ASSERT(CmdUIState.m_pMenu != NULL);

			CmdUIState.m_pSubMenu = NULL;
			CmdUIState.DoUpdate(this, CmdUIState.m_nID < 0xF000);
	}
}

void CArtDlg::OnEditClear()
{
	CEdit* pEdit = GetEditFocused();
	ASSERT(pEdit != 0);
	pEdit->Clear();
}

void CArtDlg::OnEditClearall()
{
	CEdit* pEdit = GetEditFocused();
	ASSERT(pEdit);

	pEdit->SetSel(0, -1);
	pEdit->Clear();
}

void CArtDlg::OnEditCopy()
{
	CEdit* pEdit = GetEditFocused();
	ASSERT(pEdit != NULL);

	pEdit->Copy();

}

void CArtDlg::OnEditCut()
{
	CEdit* pEdit = GetEditFocused();
	ASSERT(pEdit != NULL);

	pEdit->Cut();
}

void CArtDlg::OnEditPaste()
{
	CEdit* pEdit = GetEditFocused();
	ASSERT(pEdit != NULL);

	pEdit->Paste();
}

void CArtDlg::OnEditSelectall()
{
	CEdit* pEdit = GetEditFocused();
	ASSERT(pEdit != NULL);

	pEdit->SetSel(0, -1);
}

void CArtDlg::OnUpdateEditClearall(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(EditHasText());
}

void CArtDlg::OnUpdateEditIsSel(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(IsEditSelection());
}

void CArtDlg::OnUpdateEditPaste(CCmdUI *pCmdUI)
{
	CEdit* pEdit = GetEditFocused();

	BOOL bEnable = (pEdit != NULL);

	if(bEnable)
	{
		bEnable = IsClipboardFormatAvailable(CF_TEXT);
	}

	pCmdUI->Enable(bEnable);
}

void CArtDlg::OnUpdateEditSelectall(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(EditHasText());
}


CEdit* CArtDlg::GetEditFocused(void)
{
	HWND hWnd = ::GetFocus();

	CString csBuffer;
	LPTSTR pBuf = csBuffer.GetBufferSetLength(MAX_PATH);
	GetClassName(hWnd, pBuf, MAX_PATH);
	csBuffer.ReleaseBuffer();

	if(!csBuffer.CompareNoCase(_T("edit")))
	{
		return (CEdit*)CWnd::FromHandle(hWnd);
	}

	return NULL;

}

BOOL CArtDlg::IsEditSelection(void)
{
	int iMinSel = 0, iMaxSel = 0;

	CEdit* pEdit = GetEditFocused();

	if(NULL == pEdit)
	{
		return FALSE;
	}

	BOOL IsSel = EditHasText();

	if(IsSel)
	{
		pEdit->GetSel(iMinSel, iMaxSel);
	}


	return iMaxSel != iMinSel;
}

BOOL CArtDlg::EditHasText(void)
{
	CString csText;
	CEdit* pEdit = GetEditFocused();

	if(NULL == pEdit)
	{
		return false;
	}

	pEdit->GetWindowText(csText);

	if(!csText.IsEmpty())
	{
		return true;
	}

	return false;
}


void CArtDlg::OnHelpAboutArt()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}


void CArtDlg::OnBnClickedCheckFileEnd()
{
	m_editLineTo.EnableWindow( ! m_editLineTo.IsWindowEnabled() );

	if( ! m_editLineTo.IsWindowEnabled() )
		m_editLineTo.SetWindowTextA( _T( "" ) );
}


void CArtDlg::showCondition( int conditionNumber, BOOL setSpin )
{
	m_actualConditionNumber = conditionNumber;

	returnExpCondition( m_actualConditionNumber );

	// Delete possible multiple choice
	//m_gridConds.ResetSelectedRange( );

	refreshCondsGrid( TRUE );

	if( setSpin )
		m_spinConditionNumber.SetPos32( m_actualConditionNumber + 1 );
}

void CArtDlg::OnDeltaposSpinFileInPreview(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);

	int actSpinPos = m_spinFileInPreview.GetPos32(); // Returns the *old* position of the spin-control

	int lowRange, highRange;
	m_spinFileInPreview.GetRange32( lowRange, highRange );

	if( ((actSpinPos + pNMUpDown->iDelta) >= lowRange) && ((actSpinPos + pNMUpDown->iDelta) <= highRange) )
		actSpinPos += pNMUpDown->iDelta; 


	actProtocolFilenumber =  actSpinPos - 1;
	previewFile( actProtocolFilenumber );

	*pResult = 0;
}


void CArtDlg::OnEnChangeEditFileInPreview()
{
	int actSpinPos = m_spinFileInPreview.GetPos32(); // Returns the *old* position of the spin-control

	CString StringNewEditValue;
	m_editFileInPreview.GetWindowTextA( StringNewEditValue );

	int newEditValue = atoi( StringNewEditValue );

	int lowRange, highRange;
	m_spinFileInPreview.GetRange32( lowRange, highRange );

	if( newEditValue < lowRange)
		actSpinPos = lowRange;
	else if( newEditValue > highRange)
		actSpinPos = highRange;
	else
		actSpinPos = newEditValue;

	m_spinFileInPreview.SetPos32( actSpinPos );


	int actFilenumber =  actSpinPos - 1;
	previewFile( actFilenumber );
}

void CArtDlg::Serialize( CArchive& archive )
{
	CObject::Serialize( archive );

	m_filenames.Serialize( archive );
	m_condset->Serialize( archive );
	m_uvSet->Serialize( archive );

	int protocolFileChanges_size;

	if( archive.IsStoring( ) ) // Save
	{
		protocolFileChanges_size = protocolFileChanges.GetSize( );
		
		archive << m_tabs << m_blanks << m_crs << m_newLines << m_vertTabs << m_newPages << protocolFileChanges_size << m_outfile;
	}
	else // Load
	{
		archive >> m_tabs >> m_blanks >> m_crs >> m_newLines >> m_vertTabs >> m_newPages >> protocolFileChanges_size >> m_outfile;

		m_checkTabs.SetCheck( m_tabs );
		m_checkBlanks.SetCheck( m_blanks );
		m_checkCR.SetCheck( m_crs );
		m_checkNewLine.SetCheck( m_newLines );
		m_checkVertTab.SetCheck( m_vertTabs );
		m_checkNewPage.SetCheck( m_newPages );

		// Check whether protocol files still exist in that place
		for( int i = 0; i < m_filenames.GetSize( ); i++ )
		{
			FILE *file;
			// Check whether file exists.
			file = fopen ( m_filenames.GetAt( i ).GetBuffer( ), "r" );

			if( ! file )
			{
				m_filenames.RemoveAll( );
				
				/*CString message;
				message.Append( _T( "(Some of) the protocol files you chose in the last session\ndo not exist anymore (in that place).\nPlease select new protocol files." ) );
			
				MessageBox( message, _T("Caution"), MB_ICONSTOP | MB_OKCANCEL );*/

				break;
			}
			else
			{
				fclose( file );
			}
		}

		// Protocol file names
		if( m_filenames.GetSize( ) > 0 )
		{
			m_editFileInPreview.EnableWindow( TRUE );
			m_spinFileInPreview.EnableWindow( TRUE );
			m_spinFileInPreview.SetRange32( 1, m_filenames.GetSize() );
			m_spinFileInPreview.SetPos32( 1 );
			previewFile();
		}
		else
		{
			m_editFileInPreview.EnableWindow( FALSE );
			m_spinFileInPreview.EnableWindow( FALSE );
		}

		CString textSelected;
		textSelected.Format( _T( "of %d protocol file" ), m_filenames.GetSize() );

		if( m_filenames.GetSize() != 1 )
			textSelected.Append( "s" );

		m_staticProtocolsSelected.SetWindowTextA( textSelected );

		// Protocol file changes
		protocolFileChanges.SetSize( protocolFileChanges_size );

		for( int i = 0; i < protocolFileChanges_size; i++ )
		{
			protocolFileChanges.GetAt( i ) = new ProtocolFileChange( );
		}
	}

	// Save and load
	for( int i = 0; i < protocolFileChanges_size; i++ )
	{
		protocolFileChanges.GetAt( i )->Serialize( archive );
	}
}

void CArtDlg::OnBnClickedButtonTest1()
{
	protocolFindReplace( "Alter", "age:::" );
}

void CArtDlg::deleteProtocolFileRow( int rowNumber )
{
	ProtocolFileChange *protocolFileChange = new ProtocolFileChange;

	protocolFileChange->instruction = 0;
	protocolFileChange->intParm_1 = rowNumber - 1;

	protocolFileChanges.Add( protocolFileChange );

	previewFile( actProtocolFilenumber );

	m_gridPreview.EnsureVisible( rowNumber, 0 );
	m_gridPreview.SetSelectedRange( rowNumber, 0, rowNumber, m_gridPreview.GetColumnCount( ) );
}

void CArtDlg::deleteProtocolFileColumn( int columnNumber )
{
	ProtocolFileChange *protocolFileChange = new ProtocolFileChange;

	protocolFileChange->instruction = 1;
	protocolFileChange->intParm_1 = columnNumber - 1;

	protocolFileChanges.Add( protocolFileChange );

	previewFile( actProtocolFilenumber );

	m_gridPreview.EnsureVisible( 0, columnNumber );
	m_gridPreview.SetSelectedRange( 0, columnNumber, 0, m_gridPreview.GetRowCount( ) );
}

void CArtDlg::protocolFindReplace( CString origString, CString replaceString )
{
	ProtocolFileChange *protocolFileChange = new ProtocolFileChange;

	protocolFileChange->instruction = 2;
	protocolFileChange->stringParm_1 = origString;
	protocolFileChange->stringParm_2 = replaceString;

	protocolFileChanges.Add( protocolFileChange );

	previewFile( actProtocolFilenumber );
}

void CArtDlg::applyProtocolFileChanges( WTextFile *theTextFile )
{
	for( int i = 0; i < protocolFileChanges.GetSize( ); i++ )
	{
		ProtocolFileChange *protocolFileChange = protocolFileChanges.GetAt( i );
		int instruction = protocolFileChange->instruction;

		switch( instruction )
		{
			case 0: // delete row
				theTextFile->deleteRow( protocolFileChange->intParm_1 );
				break;
			case 1: // delete column
				theTextFile->deleteColumn( protocolFileChange->intParm_1 );
				break;
			case 2: // findReplace
				theTextFile->findReplace( protocolFileChange->stringParm_1, protocolFileChange->stringParm_2 );
				break;
		}
	}
}

void CArtDlg::undoLastProtocolFileChange( )
{
	if( protocolFileChanges.GetSize( ) > 0 )
	{
		protocolFileChanges.RemoveAt( protocolFileChanges.GetSize( ) - 1 );
		previewFile( actProtocolFilenumber );
	}
}

void CArtDlg::OnBnClickedButtonTest2()
{
}


void CArtDlg::OnProtocolfilesDeleteselectedrows()
{
	CCellRange theRange = m_gridPreview.GetSelectedCellRange( );
	int from = theRange.GetMinRow( );
	int to = theRange.GetMaxRow( );

	for( int i = from; i <= to; i++ )
		deleteProtocolFileRow( from );
}

void CArtDlg::OnUpdateProtocolfilesDeleteselectedrows(CCmdUI *pCmdUI)
{
	CCellRange theRange = m_gridPreview.GetSelectedCellRange( );
	int from = theRange.GetMinRow( );
	int to = theRange.GetMaxRow( );

	if( ( from == -1 ) || ( to == -1 ) )
		pCmdUI->Enable( false );
	else
		pCmdUI->Enable( true );
}

void CArtDlg::OnProtocolfilesDeleteselectedcolumns()
{
	CCellRange theRange = m_gridPreview.GetSelectedCellRange( );
	int from = theRange.GetMinCol( );
	int to = theRange.GetMaxCol( );

	for( int i = from; i <= to; i++ )
		deleteProtocolFileColumn( from );
}

void CArtDlg::OnUpdateProtocolfilesDeleteselectedcolumns(CCmdUI *pCmdUI)
{
	CCellRange theRange = m_gridPreview.GetSelectedCellRange( );
	int from = theRange.GetMinRow( );
	int to = theRange.GetMaxRow( );

	if( ( from == -1 ) || ( to == -1 ) )
		pCmdUI->Enable( false );
	else
		pCmdUI->Enable( true );
}

void CArtDlg::OnProtocolfilesUndolastchange()
{
	undoLastProtocolFileChange( );
}


void CArtDlg::OnUpdateProtocolfilesUndolastchange(CCmdUI *pCmdUI)
{
	if( protocolFileChanges.GetSize( ) > 0 )
		pCmdUI->Enable( true );
	else
		pCmdUI->Enable( false );
}



void CArtDlg::OnProtocolfilesFindandreplace()
{
	DialogFindAndReplace dlgFindAndReplace;

	if( dlgFindAndReplace.DoModal( ) == IDOK )
	{
		CString origString, replaceString;
		origString = dlgFindAndReplace.returnOrigString( );
		replaceString = dlgFindAndReplace.returnReplaceString( );

		protocolFindReplace( origString, replaceString );
	}
}

